<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctCopiaVersPropAlimenticia {
    
    const NOME = "FCT_COPIA_VERS_PROPALIMENTICIA";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrseqorcamento
     * @param string  $tipo
     * @param string  $cdoperador
     * @param integer $nrorg
     */
    public function executar($nrseqorcamento, $tipo, $cdoperador, $nrorg) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRSEQORCAMENTO",        Param::PARAM_INPUT,   $nrseqorcamento,  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_TIPO",                  Param::PARAM_INPUT,   $tipo,            Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_CDOPERADOR",            Param::PARAM_INPUT,   $cdoperador,      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NRORG",                 Param::PARAM_INPUT,   $nrorg,           Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRSEQORCAMENTO_GERADO",  Param::PARAM_OUTPUT,  null,             Param::PARAM_TYPE_INT, 20));
        
        $resultado = $procedure->execute();
        return (int)$resultado["P_NRSEQORCAMENTO_GERADO"];
    }
    
}

?>