/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ATIVCLIENTE                                              */
/* Tabela : ATIVCLIENTE                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 23/01/2004 - Newton N. Santos                                              */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ATIVCLIENTE
BEFORE INSERT OR UPDATE OR DELETE
ON ATIVCLIENTE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUATCL := SYSDATE;
   END IF;
   IF UPDATING THEN
      if (NVL(:OLD.CDATIVCLI,0) <> NVL(:NEW.CDATIVCLI,0)) OR
         (NVL(:OLD.DSATIVCLI,0) <> NVL(:NEW.DSATIVCLI,0)) THEN
         :NEW.DTULTATUATCL := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ATIVCLIENTE', '', 'CDATIVCLI='||:OLD.CDATIVCLI||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ATIVCLIENTE MODIFY DTULTATUATCL DEFAULT SYSDATE
/
