--- ====================================================================
--                  PROCEDIMENTO PARA ATUALIZAR ESTOQUE
--                  ------------ ---- --------- -------
--
--  PARMETROS: P_FILIMOVI   = CDIGO DA FILIAL A SER CONSIDERADA.
--              P_DTINICIAL  = DATA INICIAL PARA CLCULO DE ESTOQUE.
--              P_DTFINAL    = DATA FINAL PARA CLCULO DE ESTOQUE.
--              P_FILILANCTO = CDIGO DA FILIAL DE LANAMENTO.
--              P_NRLANCTO   = NMERO DE UM LANAMENTO (OPCIONAL).
--              P_CDPRODUTO  = CDIGO DO PRODUTO A SER EVOLUDO (OPCIONAL).
--
-- C:\WEB_501\SQL\END_CONV\SQLSERVER\4002_ESTSTP_ATUALIZA_ESTOQUE_REC.SQL
--
-- ====================================================================

IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'ATUALIZA_ESTOQUE_REC' AND
              TYPE = 'P' 		            AND
              U.UID = O.UID               AND
              U.NAME = USER)

DROP PROCEDURE ATUALIZA_ESTOQUE_REC
GO

CREATE PROCEDURE ATUALIZA_ESTOQUE_REC
                 @P_FILIMOVI   VARCHAR(04),
                 @P_DTINICIAL  DATETIME,
                 @P_DTFINAL    DATETIME,
                 @P_FILILANCTO VARCHAR(04),
                 @P_NRLANCTO   VARCHAR(10) = NULL
AS
   DECLARE @V_FILIAUX      VARCHAR(04);
   DECLARE @V_IDESTONEG    VARCHAR(04);
   DECLARE @V_DTINICIAL    DATETIME;
   DECLARE @V_DTINICAUX    DATETIME;
   DECLARE @V_DTINICEST    DATETIME;
   DECLARE @V_DTINICPOS    DATETIME;
   DECLARE @V_DTFINAL      DATETIME;
   DECLARE @V_COUNTPOS     NUMERIC(15,5);
   DECLARE @V_QTDEESTO     NUMERIC(15,5);
   DECLARE @V_VALRESTO     NUMERIC(15,5);
   DECLARE @V_VALRBRUT     NUMERIC(15,5);
   DECLARE @V_VALRESTOM1   NUMERIC(15,5);
   DECLARE @V_VALRBRUTM1   NUMERIC(15,5);
   DECLARE @V_VALRESTOM2   NUMERIC(15,5);
   DECLARE @V_VALRBRUTM2   NUMERIC(15,5);

   DECLARE @V_QTDEANTE     NUMERIC(15,5);
   DECLARE @V_VRESTANT     NUMERIC(15,5);
   DECLARE @V_VRBRUANT     NUMERIC(15,5);
   DECLARE @V_VRESTANTM1   NUMERIC(15,5);
   DECLARE @V_VRBRUANTM1   NUMERIC(15,5);
   DECLARE @V_VRESTANTM2   NUMERIC(15,5);
   DECLARE @V_VRBRUANTM2   NUMERIC(15,5);

   DECLARE @V_QTDEESTOPOS   NUMERIC(15,5);
   DECLARE @V_VALRESTOPOS   NUMERIC(15,5);
   DECLARE @V_VALRBRUTPOS   NUMERIC(15,5);
   DECLARE @V_QTDEANTEPOS   NUMERIC(15,5);
   DECLARE @V_VRESTANTPOS   NUMERIC(15,5);
   DECLARE @V_VRBRUANTPOS   NUMERIC(15,5);
   DECLARE @V_VALRESTOPOSM1 NUMERIC(15,5);
   DECLARE @V_VALRBRUTPOSM1 NUMERIC(15,5);
   DECLARE @V_VALRESTOPOSM2 NUMERIC(15,5);
   DECLARE @V_VALRBRUTPOSM2 NUMERIC(15,5);
   DECLARE @V_VRESTANTPOSM1 NUMERIC(15,5);
   DECLARE @V_VRBRUANTPOSM1 NUMERIC(15,5);
   DECLARE @V_VRESTANTPOSM2 NUMERIC(15,5);
   DECLARE @V_VRBRUANTPOSM2 NUMERIC(15,5);

   DECLARE @V_DTSALDO      DATETIME;
   DECLARE @V_EXISMOV      VARCHAR(01);
   DECLARE @V_POSIZERO     VARCHAR(01);
   DECLARE @V_DTPOSIESTQ   DATETIME;

   /* VARIVEIS DO CURSOR C_PRODUTO */
   DECLARE @V_CDFILIAL     VARCHAR(04);
   DECLARE @V_CDALMOXARIFE VARCHAR(06);
   DECLARE @V_CDLOCALESTOQ VARCHAR(06);
   DECLARE @V_NRLOTEESTQ   VARCHAR(20);
   DECLARE @V_NRSUBLOTE    VARCHAR(04);
   DECLARE @V_CDPRODUTO    VARCHAR(10);
   DECLARE @V_DTRECALCEST  DATETIME;

   /* VARIVEIS DO CURSOR C_LANCTOEST */
   DECLARE @V_IDTIPOMOVI   VARCHAR(01);
   DECLARE @V_DTLANCMOVI   DATETIME;
   DECLARE @V_VRLANCTOEST  NUMERIC(15,5);
   DECLARE @V_VRLANCTOBRUT NUMERIC(15,5);
   DECLARE @V_QTLANCTOEST  NUMERIC(15,5);
   DECLARE @V_IDALTCMEDMV  VARCHAR(01);
   DECLARE @V_CDFILILANC   VARCHAR(04);
   DECLARE @V_CURLANCESTQ  VARCHAR(10);

   DECLARE @V_NRLANCESTQ   VARCHAR(14);
   DECLARE @V_DTCUSTCALC   DATETIME;
   DECLARE @V_DTAUXILIAR   DATETIME;

   DECLARE @V_CDINDICEMF    VARCHAR(04);
   DECLARE @V_CDINDICEMF2   VARCHAR(04);

   DECLARE @V_CDTPINDICE    VARCHAR(01);
   DECLARE @V_IDPERVALOR    VARCHAR(01);
   DECLARE @V_CDTPINDICE2   VARCHAR(01);
   DECLARE @V_IDPERVALOR2   VARCHAR(01);
   DECLARE @V_VRINDICE1     NUMERIC;
   DECLARE @V_VRINDICE2     NUMERIC;
   DECLARE @V_QTRESPRODPED  NUMERIC;

   DECLARE @V_MENSAGEM      VARCHAR(200);
   DECLARE @V_CDPROD        VARCHAR(10);
   DECLARE @V_CUSTPROD      NUMERIC;
   DECLARE @V_MOVNEG        VARCHAR(01);
/*VARIVEIS PARA CALCULO DO CUSTO LOGISTICO*/

   DECLARE @V_VRCLOGDIAANT    NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAANT    NUMERIC(15,5);
   DECLARE @V_VRCUSTOLOG      NUMERIC(15,5);
   DECLARE @V_VRCUSTOSEG      NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAAM1    NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAAM2    NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAAM1    NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAAM2    NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAM1     NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAM2     NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAM1     NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAM2     NUMERIC(15,5);
   DECLARE @V_VRCUSTLOGLAN    NUMERIC(15,5);
   DECLARE @V_VRSEGULOGLAN    NUMERIC(15,5);
   DECLARE @V_VRCUSTOLOGPOS   NUMERIC(15,5);
   DECLARE @V_VRCUSTOSEGPOS   NUMERIC(15,5);

   DECLARE @V_UTILLOTE        VARCHAR(1);
   DECLARE @V_UTILALMO        VARCHAR(1);

   DECLARE @V_NRLISTA         VARCHAR(20);
   DECLARE @V_NRLISTADT       VARCHAR(20);

   DECLARE @V_NRSEQUITEM      VARCHAR(20);

   DECLARE @V_QTESTOQDIAE      NUMERIC(15,5);
   DECLARE @V_VRESTOQDIAE      NUMERIC(15,5);
   DECLARE @V_VRESTOQDIAM1E    NUMERIC(15,5);
   DECLARE @V_VRESTOQDIAM2E    NUMERIC(15,5);
   DECLARE @V_QTESTOQANTE      NUMERIC(15,5);
   DECLARE @V_DTCUSTANTE       DATETIME;
   DECLARE @V_VRESTOQANTE      NUMERIC(15,5);
   DECLARE @V_VRESTOQANTM1E    NUMERIC(15,5);
   DECLARE @V_VRESTOQANTM2E    NUMERIC(15,5);
   DECLARE @V_VRESTOQBRUTE     NUMERIC(15,5);
   DECLARE @V_VRESTOQBRUM1E    NUMERIC(15,5);
   DECLARE @V_VRESTOQBRUM2E    NUMERIC(15,5);
   DECLARE @V_VRBRUTOANTE      NUMERIC(15,5);
   DECLARE @V_VRBRUTOANTM1E    NUMERIC(15,5);
   DECLARE @V_VRBRUTOANTM2E    NUMERIC(15,5);
   DECLARE @V_IDPOSIZEROE      VARCHAR(1);
   DECLARE @V_VRCLOGDIAE       NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAANTE    NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAM1E     NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAAM1E    NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAM2E     NUMERIC(15,5);
   DECLARE @V_VRCLOGDIAAM2E    NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAE       NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAANTE    NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAM1E     NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAAM1E    NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAM2E     NUMERIC(15,5);
   DECLARE @V_VRSEGUDIAAM2E    NUMERIC(15,5);

   DECLARE @V_CDPRODPOSEST     VARCHAR(10);
   DECLARE @V_DTPOSICAO        DATETIME;
   DECLARE @V_DTULTMOVIMEN     DATETIME;
   DECLARE @V_COUNT            NUMERIC;

   DECLARE @V_DTENTRSAIDANT    DATETIME;  /*Data anterior da NF*/
   DECLARE @V_DTLANCMOVANT     DATETIME;  /*Data anterior do Item na Itlanctoest*/
   DECLARE @V_DATAPOS          DATETIME; /*Variavel auxiliar*/

   DECLARE @V_CDPRODLIST       VARCHAR(20);
   DECLARE @V_DTPOSESTPROD     DATETIME;
   DECLARE @V_QTESTQDIAENTR     NUMERIC(15,5);
   DECLARE @V_QTESTQDIASAID     NUMERIC(15,5);
   DECLARE @V_QTESTQDIARETI     NUMERIC(15,5);
   DECLARE @V_QTESTQDIADEVO     NUMERIC(15,5);
   DECLARE @V_QTESTQDIAIMPI     NUMERIC(15,5);
   DECLARE @V_QTESTQDIAIMPF     NUMERIC(15,5);
   DECLARE @V_QTESTQDIAAJUI     NUMERIC(15,5);
   DECLARE @V_QTESTQDIAAJUF     NUMERIC(15,5);
   DECLARE @V_VRESTQDIAENTR     NUMERIC(15,5);
   DECLARE @V_VRESTQDIASAID     NUMERIC(15,5);
   DECLARE @V_VRESTQDIARETI     NUMERIC(15,5);
   DECLARE @V_VRESTQDIADEVO     NUMERIC(15,5);
   DECLARE @V_VRESTQBRUDEVO     NUMERIC(15,5);
   DECLARE @V_VRESTQDIAIMPI     NUMERIC(15,5);
   DECLARE @V_VRESTQDIAIMPF     NUMERIC(15,5);
   DECLARE @V_VRESTQDIAAJUI     NUMERIC(15,5);
   DECLARE @V_VRESTQDIAAJUF     NUMERIC(15,5);
   DECLARE @V_VRESTQBRUIMPI     NUMERIC(15,5);
   DECLARE @V_VRESTQBRUIMPF     NUMERIC(15,5);
   DECLARE @V_VRESTQBRUAJUI     NUMERIC(15,5);
   DECLARE @V_VRESTQBRUAJUF     NUMERIC(15,5);

   DECLARE @V_QTESTQANTENTR     NUMERIC(15,5);
   DECLARE @V_QTESTQANTSAID     NUMERIC(15,5);
   DECLARE @V_QTESTQANTRETI     NUMERIC(15,5);
   DECLARE @V_QTESTQANTDEVO     NUMERIC(15,5);
   DECLARE @V_QTESTQANTIMPI     NUMERIC(15,5);
   DECLARE @V_QTESTQANTIMPF     NUMERIC(15,5);
   DECLARE @V_QTESTQANTAJUI     NUMERIC(15,5);
   DECLARE @V_QTESTQANTAJUF     NUMERIC(15,5);

   DECLARE @V_VRESTQANTENTR     NUMERIC(15,5);
   DECLARE @V_VRESTQANTSAID     NUMERIC(15,5);
   DECLARE @V_VRESTQANTRETI     NUMERIC(15,5);
   DECLARE @V_VRESTQANTDEVO     NUMERIC(15,5);
   DECLARE @V_VRESTQANTIMPI     NUMERIC(15,5);
   DECLARE @V_VRESTQANTIMPF     NUMERIC(15,5);
   DECLARE @V_VRESTQANTAJUI     NUMERIC(15,5);
   DECLARE @V_VRESTQANTAJUF     NUMERIC(15,5);
   DECLARE @V_VRESTBRUTENTR     NUMERIC(15,5);
   DECLARE @V_VRBRUTDIASAID     NUMERIC(15,5);
   DECLARE @V_DTLANCTOEST       DATETIME;
   DECLARE @V_PRIM              VARCHAR(1);
   DECLARE @V_QTDEANTULTE       NUMERIC(15,5);
   DECLARE @V_VRESTANTULT       NUMERIC(15,5);
   DECLARE @V_VRBRUANTULT       NUMERIC(15,5);
   DECLARE @V_IDORDEMCLC        VARCHAR(1);


BEGIN

   SET @V_CDTPINDICE    = NULL;
   SET @V_IDPERVALOR    = NULL;
   SET @V_CDINDICEMF    = NULL;
   SET @V_CDTPINDICE2   = NULL;
   SET @V_IDPERVALOR2   = NULL;
   SET @V_CDINDICEMF2   = NULL;
   SET @V_DTRECALCEST   = NULL;
   SET @V_FILIAUX       = NULL;
   SET @V_DTINICEST     = NULL;
   SET @V_DTINICPOS     = NULL;
   SET @V_DTFINAL       = NULL;
   SET @V_QTDEESTOPOS   = 0;
   SET @V_VALRESTOPOS   = 0;
   SET @V_VALRBRUTPOS   = 0;
   SET @V_VALRESTOPOSM1 = 0;
   SET @V_VALRBRUTPOSM1 = 0;
   SET @V_VALRESTOPOSM2 = 0;
   SET @V_VALRBRUTPOSM2 = 0;
   SET @V_QTDEANTEPOS   = 0;
   SET @V_VRESTANTPOS   = 0;
   SET @V_VRBRUANTPOS   = 0;
   SET @V_VRESTANTPOSM1 = 0;
   SET @V_VRBRUANTPOSM1 = 0;
   SET @V_VRESTANTPOSM2 = 0;
   SET @V_VRBRUANTPOSM2 = 0;
   SET @V_DTAUXILIAR    = NULL;
   SET @V_VRINDICE1     = 0;
   SET @V_VRINDICE2     = 0;
   SET @V_COUNTPOS      = 0;
   SET @V_IDESTONEG     = NULL;
   SET @V_QTDEESTO      = 0;
   SET @V_VALRESTO      = 0;
   SET @V_VALRBRUT      = 0;
   SET @V_VALRESTOM1    = 0;
   SET @V_VALRESTOM2    = 0;
   SET @V_DTPOSIESTQ    = NULL;
   SET @V_QTRESPRODPED  = 0;
   SET @V_COUNTPOS      = 0;
   SET @V_VRCLOGDIAANT  = 0;
   SET @V_VRSEGUDIAANT  = 0;
   SET @V_VRCUSTOLOG    = 0;
   SET @V_VRCUSTOSEG    = 0;
   SET @V_VRCLOGDIAAM1  = 0;
   SET @V_VRCLOGDIAAM2  = 0;
   SET @V_VRSEGUDIAAM1  = 0;
   SET @V_VRSEGUDIAAM2  = 0;
   SET @V_VRCLOGDIAM1   = 0;
   SET @V_VRCLOGDIAM2   = 0;
   SET @V_VRSEGUDIAM1   = 0;
   SET @V_VRSEGUDIAM2   = 0;
   SET @V_VRCUSTLOGLAN  = 0;
   SET @V_VRSEGULOGLAN  = 0;

   SELECT @V_CDTPINDICE = MAX(ISNULL(CDTPINDICE,'1')),
          @V_IDPERVALOR = MAX(ISNULL(IDPERVALOR,'2')),
          @V_CDINDICEMF  = MAX(ISNULL(CDINDICEMF,NULL)),
          @V_CDTPINDICE2 = MAX(ISNULL(CDTPINDICE2,'1')),
          @V_IDPERVALOR2 = MAX(ISNULL(IDPERVALOR2,'2')),
          @V_CDINDICEMF2 = MAX(ISNULL(CDINDICEMF2,NULL))
   FROM PARAMGERAL;

   SET @V_CDPROD = 'X';

   SELECT @V_UTILLOTE = MAX(ISNULL(IDUTILLOTE,'N')),
          @V_UTILALMO = MAX(ISNULL(IDUTILALMOX,'N'))
   FROM PARAMFILIAL
   WHERE CDFILIAL = @P_FILIMOVI;

   /*Gera um nmero randomico para chave da tabela lista que recebe os itens
     atualizados, para posterior atualizao da POSESTCONS*/

   SELECT @V_NRLISTA = CAST(CAST(ABS(ROUND((RAND()* 1000000000),0)) AS INT) AS VARCHAR);

   /*Gera um nmero randomico para chave da tabela lista que recebe as datas
    para atualizao, para posterior atualizao da POSESTCONS*/

   SELECT @V_NRLISTADT = CAST(CAST(ABS(ROUND((RAND()* 1000000000),0)) AS INT) AS VARCHAR);

   /* LER OS PRODUTOS QUE SERO ATUALIZADOS */
   DECLARE C_PRODUTO CURSOR FOR
   SELECT M.CDFILIAL, M.CDALMOXARIFE, M.CDLOCALESTOQ,
          M.NRLOTEESTQ, M.NRSUBLOTE, M.CDPRODUTO
   FROM MOVILOTE M
   WHERE M.NRMOVILOTE   = @P_FILILANCTO + @P_NRLANCTO
   UNION
   SELECT M.CDFILIAL, M.CDALMOXARIFE, M.CDLOCALESTOQ,
          M.NRLOTEESTQ, M.NRSUBLOTE, M.CDPRODUTO
   FROM MOVILOTE M
   WHERE M.NRLANCTOORIG = @P_FILILANCTO + @P_NRLANCTO;

   OPEN C_PRODUTO;
   FETCH NEXT FROM C_PRODUTO INTO @V_CDFILIAL, @V_CDALMOXARIFE, @V_CDLOCALESTOQ,
                                  @V_NRLOTEESTQ, @V_NRSUBLOTE, @V_CDPRODUTO;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF (@V_CDPROD = 'X') BEGIN
         SET @V_CDPROD = @V_CDPRODUTO;

         INSERT INTO LISTA
           (NRLISTA, CDLISTA)
         VALUES
           (@V_NRLISTA, @V_CDPRODUTO);
      END;

      IF (@V_CDPROD <> @V_CDPRODUTO) BEGIN
         IF (ISNULL(@V_UTILALMO,'N') = 'S') OR  (ISNULL(@V_UTILLOTE, 'N') = 'S') BEGIN
            EXEC TEKNISA.ATUALIZA_ESTOQUE_CONS @P_FILIMOVI, @V_CDPROD, @P_DTINICIAL, @P_DTFINAL;
            SET @V_CDPROD = @V_CDPRODUTO;
         END
         ELSE BEGIN
            SET @V_CDPROD = @V_CDPRODUTO;
            INSERT INTO LISTA
              (NRLISTA, CDLISTA)
            VALUES
              (@V_NRLISTA, @V_CDPRODUTO);
         END;
      END;

      /* BLOQUEIA O PRODUTO PARA ATUALIZAO DO ESTOQUE */
      SELECT @V_DTRECALCEST = MAX(DTRECALCEST)
      FROM PRODLCESTOQ
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (CDPRODUTO    = @V_CDPRODUTO);

      IF NOT(@V_DTRECALCEST IS NULL) BEGIN
         /* BLOQUEIA O PRODUTO PARA ATUALIZAO DO ESTOQUE */
         SELECT @V_FILIAUX = CDFILIAL
         FROM PRODLCESTOQ WITH(UPDLOCK NOWAIT)
         WHERE (CDFILIAL     = @V_CDFILIAL)     AND
               (CDALMOXARIFE = @V_CDALMOXARIFE) AND
               (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
               (CDPRODUTO    = @V_CDPRODUTO)
      END;

      /* ATUALIZA AS DATAS INICIAL/FINAL PARA ATUALIZAR TODO PERODO */

      SELECT @V_DTINICEST = MIN(DTLANCMOVI)
      FROM ITLANCTOEST
      WHERE (CDFILIMOVI   = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODMOVI   = @V_CDPRODUTO);

      SELECT @V_DTINICPOS = MIN(DTPOSIESTQ)
      FROM POSESTDIA
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO);

      /* DATA INICIAL */

      IF NOT(@V_DTRECALCEST IS NULL)     AND
         (@V_DTRECALCEST < @P_DTINICIAL) BEGIN
         SET @V_DTINICIAL = @V_DTRECALCEST;
      END
      ELSE BEGIN
         SET @V_DTINICIAL = @P_DTINICIAL;
      END;

      IF NOT(@V_DTINICEST IS NULL) OR
         NOT(@V_DTINICPOS IS NULL) BEGIN

         IF NOT(@V_DTINICEST IS NULL) BEGIN
            SET @V_DTINICAUX = @V_DTINICEST;
         END;

         IF NOT(@V_DTINICPOS IS NULL) BEGIN
            IF (@V_DTINICPOS < @V_DTINICAUX) BEGIN
                SET @V_DTINICAUX = @V_DTINICPOS;
            END;
         END;

         IF (@V_DTINICIAL < @V_DTINICAUX) BEGIN
            SET @V_DTINICIAL = @V_DTINICAUX;
         END;

         DELETE POSESTDIA
         WHERE (CDFILIAL     = @V_CDFILIAL)     AND
               (CDALMOXARIFE = @V_CDALMOXARIFE) AND
               (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
               (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
               (NRSUBLOTE    = @V_NRSUBLOTE)    AND
               (CDPRODUTO    = @V_CDPRODUTO)    AND
               (DTPOSIESTQ  <= @V_DTINICEST);
      END;

      /* DATA FINAL */

      SELECT @V_DTFINAL = MAX(DTLANCMOVI)
      FROM ITLANCTOEST
      WHERE (CDFILIMOVI   = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODMOVI   = @V_CDPRODUTO);

      IF @V_DTFINAL IS NULL BEGIN
         SET @V_DTFINAL = @P_DTFINAL;
      END
      ELSE BEGIN
         IF (@V_DTFINAL <= @P_DTFINAL) BEGIN
             SET @V_DTFINAL = @P_DTFINAL;
         END;
      END;

      /* LER SALDO INICIAL DO PRODUTO */

      SELECT @V_QTDEESTOPOS   = ROUND(ISNULL(MAX(QTESTOQDIA),0),5),
             @V_VALRESTOPOS   = ROUND(ISNULL(MAX(VRESTOQDIA),0),5),
             @V_VALRBRUTPOS   = ROUND(ISNULL(MAX(VRESTOQBRUT),0),5),
             @V_QTDEANTEPOS   = ROUND(ISNULL(MAX(QTESTOQANT),0),5),
             @V_VRESTANTPOS   = ROUND(ISNULL(MAX(VRESTOQANT),0),5),
             @V_VRBRUANTPOS   = ROUND(ISNULL(MAX(VRBRUTOANT),0),5),
             @V_VALRESTOPOSM1 = ROUND(ISNULL(MAX(VRESTOQDIAM1),0),5) ,
             @V_VALRBRUTPOSM1 = ROUND(ISNULL(MAX(VRESTOQBRUM1),0),5),
             @V_VALRESTOPOSM2 = ROUND(ISNULL(MAX(VRESTOQDIAM2),0),5) ,
             @V_VALRBRUTPOSM2 = ROUND(ISNULL(MAX(VRESTOQBRUM2),0),5),
             @V_VRESTANTPOSM1 = ROUND(ISNULL(MAX(VRESTOQANTM1),0),5) ,
             @V_VRBRUANTPOSM1 = ROUND(ISNULL(MAX(VRBRUTOANTM1),0),5),
             @V_VRESTANTPOSM2 = ROUND(ISNULL(MAX(VRESTOQANTM2),0),5) ,
             @V_VRBRUANTPOSM2 = ROUND(ISNULL(MAX(VRBRUTOANTM2),0),5),
             @V_DTAUXILIAR    = MAX(DTPOSIESTQ),
             @V_DTAUXILIAR    = MAX(DTPOSIESTQ),
             @V_VRCLOGDIAANT  = ROUND(ISNULL(MAX(VRCLOGDIAANT),0),5) ,
             @V_VRSEGUDIAANT  = ROUND(ISNULL(MAX(VRSEGUDIAANT),0),5),
             @V_VRCLOGDIAAM1  = ROUND(ISNULL(MAX(VRCLOGDIAAM1),0),5) ,
             @V_VRCLOGDIAAM2  = ROUND(ISNULL(MAX(VRCLOGDIAAM2),0),5),
             @V_VRSEGUDIAAM1  = ROUND(ISNULL(MAX(VRSEGUDIAAM1),0),5) ,
             @V_VRSEGUDIAAM2  = ROUND(ISNULL(MAX(VRSEGUDIAAM2),0),5),
             @V_VRCUSTOLOGPOS = ROUND(ISNULL(MAX(VRCLOGDIA),0),5) ,
             @V_VRCUSTOSEGPOS = ROUND(ISNULL(MAX(VRSEGUDIA),0),5),
             @V_VRCLOGDIAM1   = ROUND(ISNULL(MAX(VRCLOGDIAM1),0),5) ,
             @V_VRCLOGDIAM2   = ROUND(ISNULL(MAX(VRCLOGDIAM2),0),5),
             @V_VRSEGUDIAM1   = ROUND(ISNULL(MAX(VRSEGUDIAM1),0),5) ,
             @V_VRSEGUDIAM2   = ROUND(ISNULL(MAX(VRSEGUDIAM2),0),5)
      FROM POSESTDIA
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO)    AND
            (DTPOSIESTQ   = (SELECT MAX(DTPOSIESTQ)
                             FROM POSESTDIA
                             WHERE (CDFILIAL     = @V_CDFILIAL)     AND
                                   (CDALMOXARIFE = @V_CDALMOXARIFE) AND
                                   (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
                                   (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
                                   (NRSUBLOTE    = @V_NRSUBLOTE)    AND
                                   (CDPRODUTO    = @V_CDPRODUTO)    AND
                                   (DTPOSIESTQ   <= @V_DTINICIAL)));


      DELETE POSESTATU
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO);

      DELETE POSESTDIA
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO)    AND
            (DTPOSIESTQ   > @V_DTINICIAL);

      /* ATUALIZA SALDO DE ESTOQUE DESDE A DATA INICIAL */
      /* AT A DATA DE PROCESSAMENTO                    */

      SET @V_EXISMOV    = 'N';
      SET @V_DTSALDO    = @V_DTINICIAL + 1;
      SET @V_NRLANCESTQ = 'X';

      IF (@V_DTSALDO  <> @V_DTAUXILIAR)  BEGIN
         SET @V_QTDEESTO   = @V_QTDEESTOPOS;
         SET @V_VALRESTO   = @V_VALRESTOPOS;
         SET @V_VALRBRUT   = @V_VALRBRUTPOS;
         SET @V_VALRESTOM1 = @V_VALRESTOPOSM1;
         SET @V_VALRBRUTM1 = @V_VALRBRUTPOSM1;
         SET @V_VALRESTOM2 = @V_VALRESTOPOSM2;
         SET @V_VALRBRUTM2 = @V_VALRBRUTPOSM2;
      END
      ELSE BEGIN
         SET @V_QTDEESTO   =  @V_QTDEANTEPOS;
         SET @V_VALRESTO   =  @V_VRESTANTPOS;
         SET @V_VALRBRUT   =  @V_VRBRUANTPOS;
         SET @V_VALRESTOM1 =  @V_VRESTANTPOSM1;
         SET @V_VALRBRUTM1 =  @V_VRBRUANTPOSM1;
         SET @V_VALRESTOM2 =  @V_VRESTANTPOSM2;
         SET @V_VALRBRUTM2 =  @V_VRBRUANTPOSM2;
      END;

      SET @V_QTDEANTULTE   = @V_QTDEANTEPOS;
      SET @V_VRESTANTULT   = @V_VRESTANTPOS;
      SET @V_VRBRUANTULT   = @V_VRBRUANTPOS;

      SET @V_QTDEANTE   = @V_QTDEESTO;
      SET @V_VRESTANT   = @V_VALRESTO;
      SET @V_VRBRUANT   = @V_VALRBRUT;
      SET @V_VRESTANTM1 = @V_VALRESTOM1;
      SET @V_VRBRUANTM1 = @V_VALRBRUTM1;
      SET @V_VRESTANTM2 = @V_VALRESTOM2;
      SET @V_VRBRUANTM2 = @V_VALRBRUTM2;

      SET @V_VRCUSTOLOG = @V_VRCUSTOLOGPOS;
      SET @V_VRCUSTOSEG = @V_VRCUSTOSEGPOS;


      IF (@V_QTDEESTO <> 0) BEGIN
          SET  @V_QTDEANTE   = @V_QTDEESTOPOS;
          SET  @V_VRESTANT   = @V_VRESTANTPOS;
          SET  @V_VRBRUANT   = @V_VALRBRUTPOS;
          SET  @V_VRESTANTM1 = @V_VRESTANTPOSM1;
          SET  @V_VRBRUANTM1 = @V_VRBRUANTPOSM1;
          SET  @V_VRESTANTM2 = @V_VRESTANTPOSM2;
          SET  @V_VRBRUANTM2 = @V_VRBRUANTPOSM2;
      END;

      SET @V_MOVNEG = 'N';

      IF @V_VRCUSTOLOG <> 0 BEGIN
         SET @V_VRCLOGDIAANT  = @V_VRCUSTOLOG;
      END;

      IF (@V_VRCUSTOSEG <> 0) BEGIN
         SET @V_VRSEGUDIAANT = @V_VRCUSTOSEG;
      END;


      SET @V_DTLANCTOEST = @V_DTINICIAL;

      SET @V_QTESTQDIAENTR  = 0;  SET @V_VRESTQDIAENTR = 0;  SET @V_VRESTBRUTENTR = 0;
      SET @V_QTESTQDIAIMPI  = 0;  SET @V_VRESTQDIASAID = 0;  SET @V_VRESTQBRUIMPI = 0;
      SET @V_QTESTQDIAIMPF  = 0;  SET @V_VRESTQDIARETI = 0;  SET @V_VRESTQBRUAJUI = 0;
      SET @V_QTESTQDIAAJUI  = 0;  SET @V_VRESTQDIADEVO = 0;
      SET @V_QTESTQDIAAJUF  = 0;  SET @V_VRESTQDIAIMPI = 0;
      SET @V_QTESTQDIASAID  = 0;  SET @V_VRESTQDIAIMPF = 0;
      SET @V_QTESTQDIARETI  = 0;  SET @V_VRESTQDIAAJUI = 0;
      SET @V_QTESTQDIADEVO  = 0;  SET @V_VRESTQDIAAJUF = 0;

      SET @V_PRIM = 'S';

      DECLARE C_LANCTOEST CURSOR FOR
      SELECT IDTIPOMOVI,   DTLANCMOVI,  ISNULL(VRLANCTOEST,0),
             ISNULL (VRLANCTOBRUT,0), QTLANCTOEST, IDALTCMEDMV,
             CDFILIAL, NRLANCESTQ, NRSEQUITEM,
             ISNULL(VRCUSTLOGLAN,0) VRCUSTLOGLAN,
             ISNULL(VRSEGULOGLAN,0) VRSEGULOGLAN,
             ISNULL(IDORDEMCLC,IDTIPOMOVI) IDORDEMCLC
      FROM ITLANCTOEST
      WHERE (CDFILIMOVI   = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODMOVI   = @V_CDPRODUTO)    AND
            (DTLANCMOVI   BETWEEN @V_DTINICIAL  AND @V_DTFINAL)  AND
            (ISNULL(IDEVOLESTOQ,'S') = 'S')
      ORDER BY DTLANCMOVI, ISNULL(IDORDEMCLC,IDTIPOMOVI), NRLANCESTQ, NRSEQUITEM;

      OPEN C_LANCTOEST
      FETCH NEXT FROM C_LANCTOEST INTO @V_IDTIPOMOVI,   @V_DTLANCMOVI,   @V_VRLANCTOEST,
                                       @V_VRLANCTOBRUT, @V_QTLANCTOEST,  @V_IDALTCMEDMV,
                                       @V_CDFILILANC,   @V_CURLANCESTQ,  @V_NRSEQUITEM,
                                       @V_VRCUSTLOGLAN, @V_VRSEGULOGLAN, @V_IDORDEMCLC;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF (@V_DTLANCMOVI <> @V_DTLANCTOEST) AND (@V_PRIM <> 'S') BEGIN

            SET @V_QTESTQDIAENTR  = 0;  SET @V_VRESTQDIAENTR = 0;
            SET @V_QTESTQDIAIMPI  = 0;  SET @V_VRESTQDIASAID = 0;
            SET @V_QTESTQDIAIMPF  = 0;  SET @V_VRESTQDIARETI = 0;
            SET @V_QTESTQDIAAJUI  = 0;  SET @V_VRESTQDIADEVO = 0;
            SET @V_QTESTQDIAAJUF  = 0;  SET @V_VRESTQDIAIMPI = 0;
            SET @V_QTESTQDIASAID  = 0;  SET @V_VRESTQDIAIMPF = 0;
            SET @V_QTESTQDIARETI  = 0;  SET @V_VRESTQDIAAJUI = 0;
            SET @V_QTESTQDIADEVO  = 0;  SET @V_VRESTQDIAAJUF = 0;
            SET @V_VRESTBRUTENTR  = 0;
            SET @V_VRESTQBRUIMPI  = 0;
            SET @V_VRESTQBRUAJUI  = 0;

            SET @V_DTLANCTOEST = @V_DTLANCMOVI;

            SET @V_QTDEANTEPOS    = @V_QTDEANTE;
            SET @V_VRESTANTPOS    = @V_VRESTANT;
            SET @V_VRBRUANTPOS    = @V_VRBRUANT;
            SET @V_VRESTANTPOSM1  = @V_VRESTANTM1;
            SET @V_VRBRUANTPOSM1  = @V_VRBRUANTM1;
            SET @V_VRESTANTPOSM2  = @V_VRESTANTM2;
            SET @V_VRBRUANTPOSM2  = @V_VRBRUANTM2;

            IF @V_QTDEANTE <> 0 BEGIN
               SET @V_QTDEANTULTE   = @V_QTDEANTE;
               SET @V_VRESTANTULT   = @V_VRESTANT;
               SET @V_VRBRUANTULT   = @V_VRBRUANT;
            END;
         END;


         IF (@P_FILILANCTO = @V_CDFILILANC) AND (@P_NRLANCTO = @V_CURLANCESTQ) BEGIN

            /*CARREGADA DATA ANTERIOR DA NF E DO ITEM EM ESTOQUE*/
            SELECT @V_DTENTRSAIDANT = ISNULL(MAX(DTENTRSAIDANT),NULL),
                   @V_DTLANCMOVANT  = ISNULL(MAX(DTLANCMOVANT),NULL)
            FROM NOTAFISCAL N, LANCTOESTOQ L, ITLANCTOEST I
            WHERE
               L.CDFILIAL     = N.CDFILIAL               AND
               L.NRLANCTONF   = N.NRLANCTONF             AND
               L.CDFILIAL     = @V_CDFILILANC            AND
               L.NRLANCESTQ   = @V_CURLANCESTQ           AND
               L.CDFILIAL     = I.CDFILIAL               AND
               L.NRLANCESTQ   = I.NRLANCESTQ             AND
               I.NRSEQUITEM   = @V_NRSEQUITEM;
            /*INSERE  DATA ATUAL DO LANAMENTO E DATAS ANTERIORES DA NOTAFISCAL E
              DO ITEM EM ESTOQUE, EM UMA LISTA PARA POSTERIOR ATUALIZAO DA
              POSESTCONS*/

            IF NOT (@V_DTLANCMOVI IS NULL) BEGIN
               INSERT INTO LISTA(NRLISTA, CDLISTA)
               (SELECT @V_NRLISTADT, RIGHT('         '+@V_CDPRODUTO,10) + CONVERT(VARCHAR,@V_DTLANCMOVI+1, 103)
                WHERE
                NOT EXISTS
                (SELECT NRLISTA, RIGHT('         '+@V_CDPRODUTO,10) +CONVERT(VARCHAR,@V_DTLANCMOVI+1, 103)
                FROM LISTA
                WHERE NRLISTA = @V_NRLISTADT  AND
                      CDLISTA = RIGHT('         '+@V_CDPRODUTO,10)+CONVERT(VARCHAR,@V_DTLANCMOVI+1, 103)));
            END;

            IF NOT (@V_DTLANCMOVANT IS NULL) BEGIN
               INSERT INTO LISTA(NRLISTA, CDLISTA)
               (SELECT @V_NRLISTADT, RIGHT('         '+@V_CDPRODUTO,10)+CONVERT(VARCHAR,@V_DTLANCMOVANT+1, 103)
                WHERE
                NOT EXISTS
                (SELECT NRLISTA, RIGHT('         '+@V_CDPRODUTO,10)+CONVERT(VARCHAR,@V_DTLANCMOVANT+1, 103)
                 FROM LISTA
                 WHERE NRLISTA = @V_NRLISTADT  AND
                       CDLISTA = RIGHT('         '+@V_CDPRODUTO,10)+CONVERT(VARCHAR,@V_DTLANCMOVANT+1, 103)));
            END;

            IF NOT (@V_DTENTRSAIDANT IS NULL) BEGIN
               INSERT INTO LISTA(NRLISTA, CDLISTA)
               (SELECT @V_NRLISTADT, RIGHT('         '+@V_CDPRODUTO,10)+CONVERT(VARCHAR,@V_DTENTRSAIDANT+1, 103)
 		          WHERE
                NOT EXISTS
                (SELECT NRLISTA, RIGHT('         '+@V_CDPRODUTO,10)+CONVERT(VARCHAR,@V_DTENTRSAIDANT+1, 103)
                 FROM LISTA
                 WHERE NRLISTA = @V_NRLISTADT  AND
                       CDLISTA = RIGHT('         '+@V_CDPRODUTO,10)+CONVERT(VARCHAR,@V_DTENTRSAIDANT+1, 103)));
            END;
         END;

         IF NOT(@V_CDINDICEMF IS NULL) BEGIN

            SELECT @V_VRINDICE1 = MAX(VRINDICE)
            FROM  INDICE I, MOVINDICE M
            WHERE I.CDTPINDICE  = @V_CDTPINDICE AND
                  I.IDPERVALOR  = @V_IDPERVALOR AND
                  I.CDINDICE    = @V_CDINDICEMF AND
                  I.CDTPINDICE  = M.CDTPINDICE  AND
                  I.IDPERVALOR  = M.IDPERVALOR  AND
                  I.CDINDICE    = M.CDINDICE    AND
                  @V_DTLANCMOVI = M.DTREFIND;

            IF (ISNULL(@V_VRINDICE1,0) = 0) BEGIN
               SET @V_MENSAGEM = ('ndice Financeiro Parametrizado na Personalizao do Sistema,
                                   no Possui valor Cadastrado para a Data'+' '+  CONVERT(VARCHAR,@V_DTLANCMOVI))
               RAISERROR(@V_MENSAGEM, 16,1);
            END;
         END;

         IF NOT(@V_CDINDICEMF2 IS NULL) BEGIN

            SELECT @V_VRINDICE2 = MAX(VRINDICE)
            FROM  INDICE I, MOVINDICE M
            WHERE I.CDTPINDICE  = @V_CDTPINDICE2 AND
                  I.IDPERVALOR  = @V_IDPERVALOR2 AND
                  I.CDINDICE    = @V_CDINDICEMF2 AND
                  I.CDTPINDICE  = M.CDTPINDICE  AND
                  I.IDPERVALOR  = M.IDPERVALOR  AND
                  I.CDINDICE    = M.CDINDICE    AND
                  @V_DTLANCMOVI = M.DTREFIND;

            IF (ISNULL(@V_VRINDICE2,0) = 0) BEGIN
               SET @V_MENSAGEM = ('ndice Financeiro Parametrizado na Personalizao do Sistema,
                                   no Possui valor Cadastrado para a Data'+' '+  CONVERT(VARCHAR,@V_DTLANCMOVI))
               RAISERROR(@V_MENSAGEM,16,1);
            END;

         END;

         IF (@V_DTSALDO > @V_DTLANCMOVI) BEGIN
            SET @V_DTSALDO = (@V_DTLANCMOVI + 1);
         END;


         IF ((@V_DTLANCMOVI + 1) = @V_DTAUXILIAR) BEGIN
            SET @V_QTDEESTO   = 0;
            SET @V_VALRESTO   = 0;
            SET @V_VALRBRUT   = 0;
            SET @V_QTDEANTE   = 0;
            SET @V_VRESTANT   = 0;
            SET @V_VRBRUANT   = 0;

            SET @V_VRESTANTM1 = 0;
            SET @V_VRBRUANTM1 = 0;
            SET @V_VRESTANTM2 = 0;
            SET @V_VRBRUANTM2 = 0;

            SET @V_VRCUSTOLOG   = 0;
            SET @V_VRCUSTOSEG   = 0;
            SET @V_VRCLOGDIAANT = 0;
            SET @V_VRSEGUDIAANT = 0;

         END;

         SET @V_EXISMOV = 'S';

         /* TRATAMENTO PARA CADA REGISTRO DE LANAMENTO DE ESTOQUE */

         IF (@V_IDTIPOMOVI = '0') BEGIN /* IMPLANTAO */
            IF (@V_NRLANCESTQ <> (@V_CDFILILANC + @V_CURLANCESTQ)) BEGIN
               SET @V_VALRBRUT = @V_VRLANCTOBRUT;
               SET @V_VALRESTO = @V_VRLANCTOEST;
               SET @V_QTDEESTO = @V_QTLANCTOEST;
            END
            ELSE BEGIN
               SET @V_VALRBRUT = @V_VALRBRUT + @V_VRLANCTOBRUT;
               SET @V_VALRESTO = @V_VALRESTO + @V_VRLANCTOEST;
               SET @V_QTDEESTO = @V_QTDEESTO + @V_QTLANCTOEST;
            END
            SET @V_VRCUSTOLOG  = 0;                /*AQUI*/
            SET @V_VRCUSTOSEG  = 0;

            IF  @V_IDORDEMCLC =   'U' BEGIN
               SET @V_VRESTQDIAIMPF   = @V_VRLANCTOEST;
               SET @V_VRESTQBRUIMPF   = @V_VRLANCTOBRUT;
               SET @V_QTESTQDIAIMPF   = @V_QTLANCTOEST;
            END
            ELSE BEGIN
               SET @V_VRESTQDIAIMPI   = @V_VRLANCTOEST;
               SET @V_VRESTQBRUIMPI   = @V_VRLANCTOBRUT;
               SET @V_QTESTQDIAIMPI   = @V_QTLANCTOEST;
            END;

         END
         ELSE IF (@V_IDTIPOMOVI = '1') BEGIN /* AJUSTES */

            IF ISNULL(@V_IDALTCMEDMV,'N') <> 'S' BEGIN
               IF @V_QTDEESTO = 0 BEGIN
                  IF @V_QTDEANTE <> 0 BEGIN
                     IF (@V_QTLANCTOEST <> 0) BEGIN
                        SET @V_VALRBRUT = (@V_VRBRUANT/@V_QTDEANTE)*@V_QTLANCTOEST;
                        SET @V_VALRESTO = (@V_VRESTANT/@V_QTDEANTE)*@V_QTLANCTOEST;

                        IF @V_QTDEANTE > @V_QTLANCTOEST BEGIN
                           SET @V_VRCUSTOLOG = @V_VRCUSTOLOG - ((@V_VRCUSTOLOG/@V_QTDEANTE) * ABS(@V_QTLANCTOEST-@V_QTDEANTE));
                           SET @V_VRCUSTOSEG = @V_VRCUSTOSEG - ((@V_VRCUSTOSEG/@V_QTDEANTE) * ABS(@V_QTLANCTOEST-@V_QTDEANTE));
                        END
                        ELSE BEGIN
                           IF @V_QTDEANTE > @V_QTLANCTOEST BEGIN
                              SET @V_VRCUSTOLOG = @V_VRCUSTOLOG + ((@V_VRCUSTOLOG/@V_QTDEANTE) * ABS(@V_QTLANCTOEST-@V_QTDEANTE));
                              SET @V_VRCUSTOSEG = @V_VRCUSTOSEG + ((@V_VRCUSTOSEG/@V_QTDEANTE) * ABS(@V_QTLANCTOEST-@V_QTDEANTE));
                           END;
                        END;

                        SET @V_VRBRUANT = 0;
                        SET @V_VRESTANT = 0;
                        SET @V_QTDEANTE = 0;
                        SET @V_VRESTANTM1 = 0;
                        SET @V_VRBRUANTM1 = 0;
                        SET @V_VRESTANTM2 = 0;
                        SET @V_VRBRUANTM2 = 0;

                        SET @V_VRCLOGDIAANT = 0;
                        SET @V_VRSEGUDIAANT = 0;

                     END
                     ELSE BEGIN
                        SET @V_VALRBRUT = 0;
                        SET @V_VALRESTO = 0;
                        SET @V_VRESTANTM1 = 0;
                        SET @V_VRBRUANTM1 = 0;
                        SET @V_VRESTANTM2 = 0;
                        SET @V_VRBRUANTM2 = 0;

                        SET @V_VRCLOGDIAANT = 0;
                        SET @V_VRSEGUDIAANT = 0;
                     END;
                  END
                  ELSE BEGIN
                     IF @V_QTDEANTULTE  <> 0 BEGIN
                        IF (@V_QTLANCTOEST <> 0) BEGIN
                           SET @V_VALRBRUT = (@V_VRBRUANTULT /@V_QTDEANTULTE )* @V_QTLANCTOEST;
                           SET @V_VALRESTO = (@V_VRESTANTULT/@V_QTDEANTULTE )* @V_QTLANCTOEST;

                           IF @V_QTDEANTULTE  > @V_QTLANCTOEST BEGIN
                              SET @V_VRCUSTOLOG = @V_VRCUSTOLOG - ((@V_VRCUSTOLOG/@V_QTDEANTULTE) * ABS(@V_QTLANCTOEST-@V_QTDEANTEPOS));
                              SET @V_VRCUSTOSEG = @V_VRCUSTOSEG - ((@V_VRCUSTOSEG/@V_QTDEANTULTE) * ABS(@V_QTLANCTOEST-@V_QTDEANTEPOS));
                           END
                           ELSE BEGIN
                              IF @V_QTDEANTULTE  > @V_QTLANCTOEST BEGIN
                                 SET @V_VRCUSTOLOG = @V_VRCUSTOLOG + ((@V_VRCUSTOLOG/@V_QTDEANTULTE ) * ABS(@V_QTLANCTOEST-@V_QTDEANTEPOS));
                                 SET @V_VRCUSTOSEG = @V_VRCUSTOSEG + ((@V_VRCUSTOSEG/@V_QTDEANTULTE ) * ABS(@V_QTLANCTOEST-@V_QTDEANTEPOS));
                              END;
                           END;
                        END
                        ELSE BEGIN
                           SET @V_VALRBRUT   = 0;
                           SET @V_VALRESTO   = 0;
                           SET @V_VRBRUANT   = 0;
                           SET @V_VRESTANT   = 0;
                           SET @V_QTDEANTE   = 0;
                           SET @V_VRCLOGDIAANT = 0;
                           SET @V_VRSEGUDIAANT = 0;

                           SET @V_VRESTANTM1 = 0;
                           SET @V_VRBRUANTM1 = 0;
                           SET @V_VRESTANTM2 = 0;
                           SET @V_VRBRUANTM2 = 0;
                        END;
                     END
                     ELSE BEGIN
                        SET @V_VALRBRUT   = 0;
                        SET @V_VALRESTO   = 0;
                        SET @V_VRBRUANT   = 0;
                        SET @V_VRESTANT   = 0;
                        SET @V_QTDEANTE   = 0;
                        SET @V_VRCLOGDIAANT = 0;
                        SET @V_VRSEGUDIAANT = 0;

                        SET @V_VRESTANTM1 = 0;
                        SET @V_VRBRUANTM1 = 0;
                        SET @V_VRESTANTM2 = 0;
                        SET @V_VRBRUANTM2 = 0;
                     END;
                  END;
               END
               ELSE BEGIN
                  IF @V_QTDEESTO > @V_QTLANCTOEST BEGIN
                     SET @V_VRCUSTOLOG = @V_VRCUSTOLOG - ((@V_VRCUSTOLOG/@V_QTDEESTO) * ABS(@V_QTLANCTOEST-@V_QTDEESTO));
                     SET @V_VRCUSTOSEG = @V_VRCUSTOSEG - ((@V_VRCUSTOSEG/@V_QTDEESTO) * ABS(@V_QTLANCTOEST-@V_QTDEESTO));
                  END
                  ELSE BEGIN
                     IF @V_QTDEESTO < @V_QTLANCTOEST BEGIN
                        SET @V_VRCUSTOLOG = @V_VRCUSTOLOG + ((@V_VRCUSTOLOG/@V_QTDEESTO) * ABS(@V_QTLANCTOEST-@V_QTDEESTO));
                        SET @V_VRCUSTOSEG = @V_VRCUSTOSEG + ((@V_VRCUSTOSEG/@V_QTDEESTO) * ABS(@V_QTLANCTOEST-@V_QTDEESTO));
                     END;
                  END;
                  IF @V_QTDEESTO <> 0 BEGIN
                     SET @V_VALRBRUT = (@V_VALRBRUT/@V_QTDEESTO)*@V_QTLANCTOEST;
                     SET @V_VALRESTO = (@V_VALRESTO/@V_QTDEESTO)*@V_QTLANCTOEST;
                  END
                  ELSE BEGIN
                     IF @V_QTDEANTULTE <> 0 BEGIN
                        SET @V_VALRBRUT = (@V_VRBRUANTULT /@V_QTDEANTULTE )* @V_QTLANCTOEST;
                        SET @V_VALRESTO = (@V_VRESTANTULT/@V_QTDEANTULTE )* @V_QTLANCTOEST;
                     END;
                  END;
               END;
            END;
            SET @V_QTDEESTO = @V_QTLANCTOEST;
         END
         ELSE IF (@V_IDTIPOMOVI = '2') BEGIN /* ENTRADA */
            SET @V_QTDEESTO = @V_QTDEESTO + @V_QTLANCTOEST;

            SET @V_QTESTQDIAENTR = @V_QTESTQDIAENTR +  @V_QTLANCTOEST;
            SET @V_VRESTQDIAENTR = @V_VRESTQDIAENTR + (@V_QTLANCTOEST*@V_VRLANCTOEST);
            SET @V_VRESTBRUTENTR = @V_VRESTBRUTENTR + (@V_QTLANCTOEST*@V_VRLANCTOBRUT);


            SET @V_VRCUSTOLOG   = @V_VRCUSTOLOG +  @V_VRCUSTLOGLAN;
            SET @V_VRCUSTOSEG   = @V_VRCUSTOSEG +  @V_VRSEGULOGLAN;

            IF @V_QTLANCTOEST = 0 BEGIN
               SET @V_VALRBRUT = @V_VALRBRUT + @V_VRLANCTOBRUT;
               SET @V_VALRESTO = @V_VALRESTO + @V_VRLANCTOEST;
            END
            ELSE BEGIN
               SET @V_VALRBRUT = @V_VALRBRUT + (@V_QTLANCTOEST*@V_VRLANCTOBRUT);
               SET @V_VALRESTO = @V_VALRESTO + (@V_QTLANCTOEST*@V_VRLANCTOEST);
            END;

            IF @V_QTDEESTO  = 0 BEGIN
               SET @V_VALRBRUT = 0;
               SET @V_VALRESTO = 0;
            END;
         END
         ELSE IF (@V_IDTIPOMOVI = '3') BEGIN /* RETIRADA */
            IF @V_QTDEESTO > 0 BEGIN

               SET @V_VRESTQDIARETI = (@V_VALRESTO/@V_QTDEESTO) * @V_QTLANCTOEST;

               SET @V_VALRBRUT = @V_VALRBRUT - ((@V_VALRBRUT/@V_QTDEESTO)*@V_QTLANCTOEST);
               SET @V_VALRESTO = @V_VALRESTO - ((@V_VALRESTO/@V_QTDEESTO)*@V_QTLANCTOEST);

               SET @V_VRCUSTOLOG = @V_VRCUSTOLOG - ((@V_VRCUSTOLOG/@V_QTDEESTO) * @V_QTLANCTOEST);
               SET @V_VRCUSTOSEG = @V_VRCUSTOSEG - ((@V_VRCUSTOSEG/@V_QTDEESTO) * @V_QTLANCTOEST);
            END
            ELSE BEGIN
               SET @V_VRESTQDIARETI = (@V_VRESTANT/@V_QTDEANTE) * @V_QTLANCTOEST;
            END;

            SET @V_QTDEESTO = @V_QTDEESTO - @V_QTLANCTOEST;
            SET @V_QTESTQDIARETI = @V_QTLANCTOEST;

            IF (@V_QTDEESTO < 0) BEGIN
               IF (@V_QTDEANTE <> 0) BEGIN
                  SET @V_VALRESTO = ((@V_VRESTANT/@V_QTDEANTE)*@V_QTDEESTO);
                  SET @V_VALRBRUT = ((@V_VRBRUANT/@V_QTDEANTE)*@V_QTDEESTO);
               END
               ELSE BEGIN
                  SET @V_VALRESTO = 0;
                  SET @V_VALRBRUT = 0;
               END;
            END;

            IF ROUND(@V_QTDEESTO,3) = 0 BEGIN
               SET @V_QTDEESTO = 0;
            END;

            IF @V_QTDEESTO  = 0 BEGIN
               SET @V_VALRBRUT   = 0;
               SET @V_VALRESTO   = 0;
            END;
            IF @V_QTDEESTO < 0 BEGIN
               SET @V_MOVNEG = 'S';
            END;
         END
         ELSE IF (@V_IDTIPOMOVI = '4') BEGIN /* SADA */

            IF (@V_QTDEESTO > 0) BEGIN

               SET @V_VRESTQDIASAID = @V_VRESTQDIASAID + ((@V_VALRESTO/@V_QTDEESTO) * @V_QTLANCTOEST);
               SET @V_VRBRUTDIASAID = @V_VRBRUTDIASAID + ((@V_VALRBRUT/@V_QTDEESTO) * @V_QTLANCTOEST);

               SET @V_VALRBRUT = @V_VALRBRUT - ((@V_VALRBRUT/@V_QTDEESTO)* @V_QTLANCTOEST);
               SET @V_VALRESTO = @V_VALRESTO - ((@V_VALRESTO/@V_QTDEESTO)* @V_QTLANCTOEST);

               SET @V_VRCUSTOLOG = @V_VRCUSTOLOG - ((@V_VRCUSTOLOG/@V_QTDEESTO) * @V_QTLANCTOEST);
               SET @V_VRCUSTOSEG = @V_VRCUSTOSEG - ((@V_VRCUSTOSEG/@V_QTDEESTO) * @V_QTLANCTOEST);
            END
            ELSE BEGIN
               SET @V_VRESTQDIASAID = @V_VRESTQDIASAID + ((@V_VRESTANT/@V_QTDEANTE) * @V_QTLANCTOEST);
               SET @V_VRBRUTDIASAID = @V_VRBRUTDIASAID + ((@V_VRBRUANT/@V_QTDEANTE) * @V_QTLANCTOEST);
            END;

            SET @V_QTDEESTO = @V_QTDEESTO - @V_QTLANCTOEST;

            SET @V_QTESTQDIASAID = @V_QTESTQDIASAID + @V_QTLANCTOEST;

            IF (@V_QTDEESTO < 0) BEGIN
               IF (@V_QTDEANTE <> 0) BEGIN
                  SET @V_VALRESTO = ((@V_VRESTANT/@V_QTDEANTE)*@V_QTDEESTO);
                  SET @V_VALRBRUT = ((@V_VRBRUANT/@V_QTDEANTE)*@V_QTDEESTO);
               END
               ELSE BEGIN
                  SET @V_VALRESTO = 0;
                  SET @V_VALRBRUT = 0;
               END;
            END;

            IF ROUND(@V_QTDEESTO,3) = 0 BEGIN
               SET @V_QTDEESTO = 0;
            END;

            IF @V_QTDEESTO  = 0 BEGIN
               SET @V_VALRBRUT   = 0;
               SET @V_VALRESTO   = 0;
            END;
            IF @V_QTDEESTO < 0 BEGIN
               SET @V_MOVNEG = 'S';
            END;
         END
         ELSE IF (@V_IDTIPOMOVI = '5') BEGIN /* DEV. FORN. */

            IF @V_QTLANCTOEST = 0 BEGIN
               SET @V_VALRBRUT = @V_VALRBRUT - @V_VRLANCTOBRUT;
               SET @V_VALRESTO = @V_VALRESTO - @V_VRLANCTOEST;
            END
            ELSE BEGIN
               SET @V_CUSTPROD = 0;

               IF @V_QTDEESTO <> 0 BEGIN
                  SET @V_CUSTPROD = @V_VALRBRUT / @V_QTDEESTO;
               END
               ELSE BEGIN
                  IF @V_QTDEANTE <> 0 BEGIN
                     SET @V_CUSTPROD = @V_VRBRUANT / @V_QTDEANTE;
                  END;
               END;

               IF (@V_VALRBRUT - (@V_QTLANCTOEST*@V_VRLANCTOBRUT)) >= 0 BEGIN
                  SET @V_VALRBRUT = @V_VALRBRUT - (@V_QTLANCTOEST*@V_VRLANCTOBRUT);
               END
               ELSE BEGIN
                  SET @V_VALRBRUT = @V_VALRBRUT - (@V_QTLANCTOEST*@V_CUSTPROD);
               END;

               SET @V_CUSTPROD = 0;
               IF @V_QTDEESTO <> 0 BEGIN
                  SET @V_CUSTPROD = @V_VALRESTO / @V_QTDEESTO;
               END
               ELSE BEGIN
                  IF @V_QTDEANTE <> 0 BEGIN
                     SET @V_CUSTPROD = @V_VRESTANT / @V_QTDEANTE;
                  END;
               END;

               IF (@V_VALRESTO - (@V_QTLANCTOEST*@V_VRLANCTOEST)) >= 0 BEGIN
                  SET @V_VALRESTO = @V_VALRESTO - (@V_QTLANCTOEST*@V_VRLANCTOEST);
               END
               ELSE BEGIN
                  SET @V_VALRESTO = @V_VALRESTO - (@V_QTLANCTOEST*@V_CUSTPROD);
               END;
               IF @V_QTDEESTO < 0 BEGIN
                  SET @V_MOVNEG = 'S';
               END;
            END;

            SET @V_QTDEESTO      = @V_QTDEESTO - @V_QTLANCTOEST;
            SET @V_VRESTQDIADEVO = (@V_QTLANCTOEST * @V_CUSTPROD);
            SET @V_VRESTQBRUDEVO = (@V_QTLANCTOEST * @V_VRLANCTOBRUT);
            SET @V_QTESTQDIADEVO = @V_QTLANCTOEST;

            IF ROUND(@V_QTDEESTO,3) = 0 BEGIN
               SET @V_QTDEESTO = 0;
            END;

            IF @V_QTDEESTO  = 0 BEGIN
               SET @V_VALRBRUT = 0;
               SET @V_VALRESTO = 0;
            END;
         END;

         /* GRAVAO DOS SALDOS DIRIOS PARA O PRODUTO */
         WHILE (@V_DTSALDO <= (@V_DTLANCMOVI + 1)) BEGIN
            IF (@V_CDINDICEMF IS NOT NULL) BEGIN
               SET @V_VALRBRUTM1  = @V_VALRBRUT / @V_VRINDICE1;
               SET @V_VALRESTOM1  = @V_VALRESTO / @V_VRINDICE1;

               SET @V_VRCLOGDIAM1 = @V_VRCUSTOLOG / @V_VRINDICE1;
               SET @V_VRSEGUDIAM1 = @V_VRCUSTOSEG / @V_VRINDICE1;
            END;

            IF (@V_CDINDICEMF2 IS NOT NULL) BEGIN
               SET @V_VALRBRUTM2 = @V_VALRBRUT / @V_VRINDICE2;
               SET @V_VALRESTOM2 = @V_VALRESTO / @V_VRINDICE2;

               SET @V_VRCLOGDIAM2 = @V_VRCUSTOLOG / @V_VRINDICE2;
               SET @V_VRSEGUDIAM2 = @V_VRCUSTOSEG / @V_VRINDICE2;
            END;

            SELECT @V_COUNTPOS = COUNT(*)
            FROM POSESTDIA
            WHERE (CDFILIAL     = @V_CDFILIAL)     AND
                  (CDALMOXARIFE = @V_CDALMOXARIFE) AND
                  (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
                  (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
                  (NRSUBLOTE    = @V_NRSUBLOTE)    AND
                  (CDPRODUTO    = @V_CDPRODUTO)    AND
                  (DTPOSIESTQ   = @V_DTSALDO);

            IF (@V_COUNTPOS = 0) BEGIN
               IF @V_QTDEESTO = 0 BEGIN
                  SET @V_POSIZERO = 'S';
               END
               ELSE BEGIN
                  SET @V_POSIZERO = 'N';
               END;

               IF (@V_DTSALDO > @V_DTLANCMOVI) BEGIN
                  INSERT INTO POSESTDIA
                     (CDFILIAL,     CDALMOXARIFE,  CDLOCALESTOQ, NRLOTEESTQ,    NRSUBLOTE,   CDPRODUTO,
                      DTPOSIESTQ,   QTESTOQDIA,    VRESTOQDIA,   VRESTOQBRUT,   IDPOSIZERO,
                      QTESTOQANT,   VRESTOQANT,    VRBRUTOANT,   VRESTOQDIAM1,  VRESTOQBRUM1,
                      VRESTOQANTM1, VRBRUTOANTM1,  VRESTOQDIAM2, VRESTOQBRUM2,  VRESTOQANTM2,
                      VRBRUTOANTM2, VRCLOGDIAANT,  VRSEGUDIAANT,  VRCLOGDIA,    VRSEGUDIA,
                      VRCLOGDIAAM1, VRCLOGDIAAM2,  VRSEGUDIAAM1, VRSEGUDIAAM2,
                      VRCLOGDIAM1,  VRCLOGDIAM2,   VRSEGUDIAM1,  VRSEGUDIAM2,
                      ---------------------------------------------------------
                      QTESTQDIAENTR, QTESTQDIAIMPI, QTESTQDIAIMPF, QTESTQDIAAJUI, QTESTQDIAAJUF, QTESTQDIASAID,
                      QTESTQDIARETI, QTESTQDIADEVO, VRESTQDIAENTR, VRESTQDIASAID, VRESTQDIARETI, VRESTQDIADEVO,
                      VRESTQDIAIMPI, VRESTQDIAIMPF, VRESTQDIAAJUI, VRESTQDIAAJUF, VRBRUTOENTR,   VRBRUTOIMPI,
                      VRBRUTOAJUI)
                   VALUES
                     (@V_CDFILIAL,  @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ, @V_NRSUBLOTE,
                      @V_CDPRODUTO, @V_DTSALDO,  @V_QTDEESTO,  @V_VALRESTO,  @V_VALRBRUT ,
                      @V_POSIZERO,  @V_QTDEANTE, @V_VRESTANT,  @V_VRBRUANT,  @V_VALRESTOPOSM1, @V_VALRBRUTPOSM1,
                      @V_VRESTANTPOSM1, @V_VRBRUANTPOSM1, @V_VALRESTOPOSM1, @V_VALRBRUTPOSM1, @V_VRESTANTPOSM1,
                      @V_VRBRUANTPOSM1, @V_VRCLOGDIAANT,  @V_VRSEGUDIAANT,  @V_VRCUSTOLOG,   @V_VRCUSTOSEG,
                      @V_VRCLOGDIAAM1,  @V_VRCLOGDIAAM2,  @V_VRSEGUDIAAM1,  @V_VRSEGUDIAAM2,
                      @V_VRCLOGDIAM1,   @V_VRCLOGDIAM2,   @V_VRSEGUDIAM1,   @V_VRSEGUDIAM2,
                      ---------------------------------------------------------
                      @V_QTESTQDIAENTR, @V_QTESTQDIAIMPI, @V_QTESTQDIAIMPF, @V_QTESTQDIAAJUI, @V_QTESTQDIAAJUF, @V_QTESTQDIASAID,
                      @V_QTESTQDIARETI, @V_QTESTQDIADEVO,
                      @V_VRESTQDIAENTR, @V_VRESTQDIASAID, @V_VRESTQDIARETI, @V_VRESTQDIADEVO, @V_VRESTQDIAIMPI, @V_VRESTQDIAIMPF,
                      @V_VRESTQDIAAJUI, @V_VRESTQDIAAJUF, @V_VRESTBRUTENTR, @V_VRESTQBRUIMPI, @V_VRESTQBRUAJUI);
               END;
            END
            ELSE BEGIN
               IF (@V_DTSALDO < (@V_DTLANCMOVI + 1)) BEGIN
                  IF @V_QTDEESTOPOS = 0 BEGIN
                     SET @V_POSIZERO = 'S';
                  END
                  ELSE BEGIN
                     SET @V_POSIZERO = 'N';
                  END;

                  UPDATE POSESTDIA
                  SET QTESTOQDIA    = @V_QTDEESTOPOS,
                      VRESTOQDIA    = @V_VALRESTOPOS,
                      VRESTOQBRUT   = @V_VALRBRUTPOS,
                      IDPOSIZERO    = @V_POSIZERO,
                      QTESTOQANT    = @V_QTDEANTEPOS,
                      VRESTOQANT    = @V_VRESTANTPOS,
                      VRBRUTOANT    = @V_VRBRUANTPOS,
                      VRESTOQDIAM1  = @V_VALRESTOPOSM1,
                      VRESTOQBRUM1  = @V_VALRBRUTPOSM1,
                      VRESTOQDIAM2  = @V_VALRESTOPOSM2,
                      VRESTOQBRUM2  = @V_VALRBRUTPOSM2,
                      VRESTOQANTM1  = @V_VRESTANTPOSM1,
                      VRBRUTOANTM1  = @V_VRBRUANTPOSM1,
                      VRESTOQANTM2  = @V_VRESTANTPOSM2,
                      VRBRUTOANTM2  = @V_VRBRUANTPOSM2,
                      VRCLOGDIAANT  = @V_VRCLOGDIAANT,
                      VRSEGUDIAANT  = @V_VRSEGUDIAANT,
                      VRCLOGDIA     = @V_VRCUSTOLOGPOS,
                      VRSEGUDIA     = @V_VRCUSTOSEGPOS,
                      VRCLOGDIAAM1  = @V_VRCLOGDIAAM1,
                      VRCLOGDIAAM2  = @V_VRCLOGDIAAM2,
                      VRSEGUDIAAM1  = @V_VRSEGUDIAAM1,
                      VRSEGUDIAAM2  = @V_VRSEGUDIAAM2,
                      VRCLOGDIAM1   = @V_VRCLOGDIAM1,
                      VRCLOGDIAM2   = @V_VRCLOGDIAM2,
                      VRSEGUDIAM1   = @V_VRSEGUDIAM1,
                      VRSEGUDIAM2   = @V_VRSEGUDIAM2,
                      QTESTQDIAENTR  =  @V_QTESTQDIAENTR,
                      QTESTQDIAIMPI  =  @V_QTESTQDIAIMPI,
                      QTESTQDIAAJUI  =  @V_QTESTQDIAAJUI,
                      QTESTQDIAIMPF  =  @V_QTESTQDIAIMPF,
                      QTESTQDIAAJUF  =  @V_QTESTQDIAAJUF,
                      QTESTQDIASAID  =  @V_QTESTQDIASAID,
                      QTESTQDIARETI  =  @V_QTESTQDIARETI,
                      QTESTQDIADEVO  =  @V_QTESTQDIADEVO,
                      ----------------------------------
                      VRESTQDIAENTR  =  @V_VRESTQDIAENTR,
                      VRESTQDIASAID  =  @V_VRESTQDIASAID,
                      VRESTQDIARETI  =  @V_VRESTQDIARETI,
                      VRESTQDIADEVO  =  @V_VRESTQDIADEVO,
                      VRESTQDIAIMPI  =  @V_VRESTQDIAIMPI,
                      VRESTQDIAIMPF  =  @V_VRESTQDIAIMPF,
                      VRESTQDIAAJUI  =  @V_VRESTQDIAAJUI,
                      VRESTQDIAAJUF  =  @V_VRESTQDIAAJUF,
                      VRBRUTOENTR    =  @V_VRESTBRUTENTR,
                      VRBRUTOIMPI    =  @V_VRESTQBRUIMPI,
                      VRBRUTOAJUI    =  @V_VRESTQBRUAJUI
                  WHERE (CDFILIAL     = @V_CDFILIAL)     AND
                        (CDALMOXARIFE = @V_CDALMOXARIFE) AND
                        (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
                        (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
                        (NRSUBLOTE    = @V_NRSUBLOTE)    AND
                        (CDPRODUTO    = @V_CDPRODUTO)    AND
                        (DTPOSIESTQ   = @V_DTSALDO);
               END
               ELSE BEGIN
                  IF @V_QTDEESTO = 0 BEGIN
                     SET @V_POSIZERO = 'S';
                  END
                  ELSE BEGIN
                     SET @V_POSIZERO = 'N';
                  END;

                  UPDATE POSESTDIA
                  SET QTESTOQDIA    = @V_QTDEESTO,
                      VRESTOQDIA    = @V_VALRESTO,
                      VRESTOQBRUT   = @V_VALRBRUT,
                      IDPOSIZERO    = @V_POSIZERO,
                      QTESTOQANT    = @V_QTDEANTEPOS,
                      VRESTOQANT    = @V_VRESTANTPOS,
                      VRBRUTOANT    = @V_VRBRUANTPOS,
                      VRESTOQDIAM1  = @V_VALRESTOM1,
                      VRESTOQBRUM1  = @V_VALRBRUTM1,
                      VRESTOQDIAM2  = @V_VALRESTOM2,
                      VRESTOQBRUM2  = @V_VALRBRUTM2,
                      VRESTOQANTM1  = @V_VRESTANTM1,
                      VRBRUTOANTM1  = @V_VRBRUANTM1,
                      VRESTOQANTM2  = @V_VRESTANTM2,
                      VRBRUTOANTM2  = @V_VRBRUANTM2,
                      VRCLOGDIAANT  = @V_VRCLOGDIAANT,
                      VRSEGUDIAANT  = @V_VRSEGUDIAANT,
                      VRCLOGDIA     = @V_VRCUSTOLOG,
                      VRSEGUDIA     = @V_VRCUSTOSEG,
                      VRCLOGDIAAM1  = @V_VRCLOGDIAAM1,
                      VRCLOGDIAAM2  = @V_VRCLOGDIAAM2,
                      VRSEGUDIAAM1  = @V_VRSEGUDIAAM1,
                      VRSEGUDIAAM2  = @V_VRSEGUDIAAM2,
                      VRCLOGDIAM1   = @V_VRCLOGDIAM1,
                      VRCLOGDIAM2   = @V_VRCLOGDIAM2,
                      VRSEGUDIAM1   = @V_VRSEGUDIAM1,
                      VRSEGUDIAM2   = @V_VRSEGUDIAM2,
                      QTESTQDIAENTR  =  @V_QTESTQDIAENTR,
                      QTESTQDIAIMPI  =  @V_QTESTQDIAIMPI,
                      QTESTQDIAAJUI  =  @V_QTESTQDIAAJUI,
                      QTESTQDIAIMPF  =  @V_QTESTQDIAIMPF,
                      QTESTQDIAAJUF  =  @V_QTESTQDIAAJUF,
                      QTESTQDIASAID  =  @V_QTESTQDIASAID,
                      QTESTQDIARETI  =  @V_QTESTQDIARETI,
                      QTESTQDIADEVO  =  @V_QTESTQDIADEVO,
                      ----------------------------------
                      VRESTQDIAENTR  =  @V_VRESTQDIAENTR,
                      VRESTQDIASAID  =  @V_VRESTQDIASAID,
                      VRESTQDIARETI  =  @V_VRESTQDIARETI,
                      VRESTQDIADEVO  =  @V_VRESTQDIADEVO,
                      VRESTQDIAIMPI  =  @V_VRESTQDIAIMPI,
                      VRESTQDIAIMPF  =  @V_VRESTQDIAIMPF,
                      VRESTQDIAAJUI  =  @V_VRESTQDIAAJUI,
                      VRESTQDIAAJUF  =  @V_VRESTQDIAAJUF,
                      VRBRUTOENTR    =  @V_VRESTBRUTENTR,
                      VRBRUTOIMPI    =  @V_VRESTQBRUIMPI,
                      VRBRUTOAJUI    =  @V_VRESTQBRUAJUI
                  WHERE (CDFILIAL     = @V_CDFILIAL)     AND
                        (CDALMOXARIFE = @V_CDALMOXARIFE) AND
                        (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
                        (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
                        (NRSUBLOTE    = @V_NRSUBLOTE)    AND
                        (CDPRODUTO    = @V_CDPRODUTO)    AND
                        (DTPOSIESTQ   = @V_DTSALDO);
               END;
            END;
            SET @V_DTSALDO  = @V_DTSALDO + 1;
         END;
         /* GUARDA OS VALORES DE ESTOQUE ANTERIORES  PRXIMA MOVIMENTAO */

         SET @V_QTDEESTOPOS   = @V_QTDEESTO;
         SET @V_VALRESTOPOS   = @V_VALRESTO;
         SET @V_VALRBRUTPOS   = @V_VALRBRUT;
         SET @V_VALRESTOPOSM1 = @V_VALRESTOM1;
         SET @V_VALRBRUTPOSM1 = @V_VALRBRUTM1;
         SET @V_VALRESTOPOSM2 = @V_VALRESTOM2;
         SET @V_VALRBRUTPOSM2 = @V_VALRBRUTM2;
         SET @V_VRCUSTOLOGPOS = @V_VRCUSTOLOG;
         SET @V_VRCUSTOSEGPOS = @V_VRCUSTOSEG;

         SET @V_NRLANCESTQ = (@V_CDFILILANC + @V_CURLANCESTQ);

         SET @V_PRIM       = 'N';

         SET @V_QTDEANTE   = @V_QTDEESTO;
         SET @V_VRESTANT   = @V_VALRESTO;
         SET @V_VRBRUANT   = @V_VALRBRUT;
         SET @V_VRESTANTM1 = @V_VALRESTOM1;
         SET @V_VRBRUANTM1 = @V_VALRBRUTM1;
         SET @V_VRESTANTM2 = @V_VALRESTOM2;
         SET @V_VRBRUANTM2 = @V_VALRBRUTM2;
         SET @V_VRCUSTOLOG = @V_VRCUSTOLOGPOS;
         SET @V_VRCUSTOSEG = @V_VRCUSTOSEGPOS;


         FETCH NEXT FROM C_LANCTOEST INTO @V_IDTIPOMOVI,   @V_DTLANCMOVI,   @V_VRLANCTOEST,
                                          @V_VRLANCTOBRUT, @V_QTLANCTOEST,  @V_IDALTCMEDMV,
                                          @V_CDFILILANC,   @V_CURLANCESTQ,  @V_NRSEQUITEM,
                                          @V_VRCUSTLOGLAN, @V_VRSEGULOGLAN, @V_IDORDEMCLC;
      END;
      CLOSE C_LANCTOEST;
      DEALLOCATE C_LANCTOEST;

      UPDATE PRODLCESTOQ
      SET DTRECALCEST  = @V_DTSALDO-1
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (CDPRODUTO    = @V_CDPRODUTO);


      SELECT @V_IDESTONEG = MAX(CDFILIAL)
      FROM POSESTDIA
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO)    AND
            (DTPOSIESTQ   > @P_DTINICIAL)    AND
            (QTESTOQDIA   < 0);

      UPDATE POSESTDIA
      SET VRESTOQDIA    = 0,
          VRESTOQBRUT   = 0,
          VRESTOQDIAM1  = 0,
          VRESTOQBRUM1  = 0,
          VRESTOQDIAM2  = 0,
          VRESTOQBRUM2  = 0,
          VRCLOGDIAM1   = 0,
          VRCLOGDIAM2   = 0,
          VRSEGUDIAM1   = 0,
          VRSEGUDIAM2   = 0
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO)    AND
            (QTESTOQDIA   = 0)               AND
            (DTPOSIESTQ  >= @P_DTINICIAL);

      UPDATE POSESTDIA
      SET VRESTOQANT    = 0,
          VRESTOQANTM1  = 0,
          VRESTOQANTM2  = 0,
          VRBRUTOANT    = 0,
          VRBRUTOANTM1  = 0,
          VRBRUTOANTM2  = 0,
          VRCLOGDIAAM1  = 0,
          VRCLOGDIAAM2  = 0,
          VRSEGUDIAAM1  = 0,
          VRSEGUDIAAM2  = 0
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO)    AND
            (QTESTOQANT   = 0)               AND
            (DTPOSIESTQ  >= @P_DTINICIAL);

      SELECT @V_QTDEESTO    = ROUND(ISNULL(MAX(QTESTOQDIA),0),5),
             @V_VALRESTO    = ROUND(ISNULL(MAX(VRESTOQDIA),0),5),
             @V_VALRBRUT    = ROUND(ISNULL(MAX(VRESTOQBRUT),0),5),
             @V_VALRESTOM1  = ROUND(ISNULL(MAX(VRESTOQDIAM1),0),5),
             @V_VALRESTOM2  = ROUND(ISNULL(MAX(VRESTOQDIAM2),0),5),
             @V_DTPOSIESTQ  = MAX(DTPOSIESTQ),
             @V_VRCUSTOLOG  = ROUND(ISNULL(MAX(VRCLOGDIA),0),5),
             @V_VRCLOGDIAM1 = ROUND(ISNULL(MAX(VRCLOGDIAM1),0),5),
             @V_VRCLOGDIAM2 = ROUND(ISNULL(MAX(VRCLOGDIAM2),0),5),
             @V_VRCUSTOSEG  = ROUND(ISNULL(MAX(VRSEGUDIA),0),5),
             @V_VRSEGUDIAM1 = ROUND(ISNULL(MAX(VRSEGUDIAM1),0),5),
             @V_VRSEGUDIAM2 = ROUND(ISNULL(MAX(VRSEGUDIAM2),0),5)
      FROM POSESTDIA
      WHERE (CDFILIAL     = @V_CDFILIAL)     AND
            (CDALMOXARIFE = @V_CDALMOXARIFE) AND
            (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
            (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
            (NRSUBLOTE    = @V_NRSUBLOTE)    AND
            (CDPRODUTO    = @V_CDPRODUTO)    AND
            (DTPOSIESTQ   = (SELECT MAX(DTPOSIESTQ)
                             FROM POSESTDIA
                             WHERE (CDFILIAL     = @V_CDFILIAL)     AND
                                   (CDALMOXARIFE = @V_CDALMOXARIFE) AND
                                   (CDLOCALESTOQ = @V_CDLOCALESTOQ) AND
                                   (NRLOTEESTQ   = @V_NRLOTEESTQ)   AND
                                   (NRSUBLOTE    = @V_NRSUBLOTE)    AND
                                   (CDPRODUTO    = @V_CDPRODUTO)));

      IF (@V_IDESTONEG IS NULL) BEGIN
         IF (@V_MOVNEG <> 'S') BEGIN
            SELECT @V_QTRESPRODPED = ISNULL(SUM(QTRESPRODPED),0)
            FROM RESERPRODPED
            WHERE CDFILIAL     = @V_CDFILIAL     AND
                  CDALMOXARIFE = @V_CDALMOXARIFE AND
                  CDLOCALESTOQ = @V_CDLOCALESTOQ AND
                  NRLOTEESTQ   = @V_NRLOTEESTQ   AND
                  NRSUBLOTE    = @V_NRSUBLOTE    AND
                  CDPRODUTO    = @V_CDPRODUTO;

            SET @V_QTRESPRODPED = @V_QTDEESTO - @V_QTRESPRODPED;
            IF @V_QTRESPRODPED >= 0 BEGIN
               IF (@V_QTDEESTO = 0) BEGIN
                  UPDATE LOTE
                  SET IDSTATLOTE = 'E'
                  WHERE CDFILIAL   = @V_CDFILIAL   AND
                        CDPRODUTO  = @V_CDPRODUTO  AND
                        NRLOTEESTQ = @V_NRLOTEESTQ AND
                        NRSUBLOTE  = @V_NRSUBLOTE;

                  DELETE MOVILOTE
                  WHERE NRMOVILOTE   = @P_FILILANCTO + @P_NRLANCTO AND
                        CDFILIAL     = @V_CDFILIAL         AND
                        CDALMOXARIFE = @V_CDALMOXARIFE     AND
                        CDLOCALESTOQ = @V_CDLOCALESTOQ     AND
                        NRLOTEESTQ   = @V_NRLOTEESTQ       AND
                        NRSUBLOTE    = @V_NRSUBLOTE        AND
                        CDPRODUTO    = @V_CDPRODUTO;

                  DELETE MOVILOTE
                  WHERE NRLANCTOORIG = @P_FILILANCTO + @P_NRLANCTO AND
                        CDFILIAL     = @V_CDFILIAL         AND
                        CDALMOXARIFE = @V_CDALMOXARIFE     AND
                        CDLOCALESTOQ = @V_CDLOCALESTOQ     AND
                        NRLOTEESTQ   = @V_NRLOTEESTQ       AND
                        NRSUBLOTE    = @V_NRSUBLOTE        AND
                        CDPRODUTO    = @V_CDPRODUTO;

               END
               ELSE IF (@V_QTDEESTO > 0) BEGIN
                  UPDATE LOTE
                  SET IDSTATLOTE = 'L'
                  WHERE CDFILIAL   = @V_CDFILIAL   AND
                        CDPRODUTO  = @V_CDPRODUTO  AND
                        NRLOTEESTQ = @V_NRLOTEESTQ AND
                        NRSUBLOTE  = @V_NRSUBLOTE;

                  DELETE FROM MOVILOTE
                  WHERE NRMOVILOTE   = @P_FILILANCTO + @P_NRLANCTO AND
                        CDFILIAL     = @V_CDFILIAL                 AND
                        CDALMOXARIFE = @V_CDALMOXARIFE             AND
                        CDLOCALESTOQ = @V_CDLOCALESTOQ             AND
                        NRLOTEESTQ   = @V_NRLOTEESTQ               AND
                        NRSUBLOTE    = @V_NRSUBLOTE                AND
                        CDPRODUTO    = @V_CDPRODUTO;

                  DELETE FROM MOVILOTE
                  WHERE NRLANCTOORIG = @P_FILILANCTO + @P_NRLANCTO AND
                        CDFILIAL     = @V_CDFILIAL                 AND
                        CDALMOXARIFE = @V_CDALMOXARIFE             AND
                        CDLOCALESTOQ = @V_CDLOCALESTOQ             AND
                        NRLOTEESTQ   = @V_NRLOTEESTQ               AND
                        NRSUBLOTE    = @V_NRSUBLOTE                AND
                        CDPRODUTO    = @V_CDPRODUTO;
               END;
            END;
         END;
      END;

      IF (@V_QTDEESTO <> 0) BEGIN
          SELECT @V_COUNTPOS = COUNT(*)
          FROM POSESTATU
          WHERE CDFILIAL     = @V_CDFILIAL     AND
                CDALMOXARIFE = @V_CDALMOXARIFE AND
                CDLOCALESTOQ = @V_CDLOCALESTOQ AND
                NRLOTEESTQ   = @V_NRLOTEESTQ   AND
                NRSUBLOTE    = @V_NRSUBLOTE    AND
                CDPRODUTO    = @V_CDPRODUTO;

          IF (@V_COUNTPOS = 0) BEGIN
             INSERT INTO POSESTATU
                (CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,
                 QTTOTALESTOQ, VRTOTALESTOQ, DTULTMOVIMEN, VRTOTALESTM1, VRTOTALESTM2,
                 VRCLOGATU, VRCLOGATUM1,VRCLOGATUM2,VRSEGUATU,VRSEGUATUM1,VRSEGUATUM2)
             VALUES
                (@V_CDFILIAL,   @V_CDPRODUTO,  @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                 @V_NRSUBLOTE,  @V_QTDEESTO,   @V_VALRESTO, @V_DTPOSIESTQ, @V_VALRESTOM1, @V_VALRESTOM2,
                 @V_VRCUSTOLOG, @V_VRCLOGDIAM1,@V_VRCLOGDIAM2, @V_VRCUSTOSEG, @V_VRSEGUDIAM1, @V_VRSEGUDIAM2);
          END
          ELSE BEGIN
             UPDATE POSESTATU
             SET QTTOTALESTOQ = @V_QTDEESTO,
                 VRTOTALESTOQ = @V_VALRESTO,
                 VRTOTALESTM1 = @V_VALRESTOM2,
                 VRTOTALESTM2 = @V_VALRESTOM2,
                 DTULTMOVIMEN = @V_DTPOSIESTQ,
                 VRCLOGATU    = @V_VRCUSTOLOG,
                 VRCLOGATUM1  = @V_VRCLOGDIAM1,
                 VRCLOGATUM2  = @V_VRCLOGDIAM2,
                 VRSEGUATU    = @V_VRCUSTOSEG,
                 VRSEGUATUM1  = @V_VRSEGUDIAM1,
                 VRSEGUATUM2  = @V_VRSEGUDIAM2
             WHERE CDFILIAL     =  @V_CDFILIAL     AND
                   CDALMOXARIFE = @V_CDALMOXARIFE AND
                   CDLOCALESTOQ = @V_CDLOCALESTOQ AND
                   NRLOTEESTQ   = @V_NRLOTEESTQ   AND
                   NRSUBLOTE    = @V_NRSUBLOTE    AND
                   CDPRODUTO    = @V_CDPRODUTO;
          END;
      END;

      FETCH NEXT FROM C_PRODUTO INTO @V_CDFILIAL, @V_CDALMOXARIFE, @V_CDLOCALESTOQ,
                                     @V_NRLOTEESTQ, @V_NRSUBLOTE, @V_CDPRODUTO;
   END;
   CLOSE C_PRODUTO;
   DEALLOCATE C_PRODUTO;


   IF (ISNULL(@V_UTILALMO,'N') = 'S') OR  (ISNULL(@V_UTILLOTE, 'N') = 'S') BEGIN
      EXEC TEKNISA.ATUALIZA_ESTOQUE_CONS @P_FILIMOVI, @V_CDPROD, @P_DTINICIAL, @P_DTFINAL;
   END
   ELSE BEGIN

/*Verifica data para atualziao da POSESTCONS e insere na tabela de lista um registro
  com PRODUTO+DTAINICIAL e outro para PRODUTODATAFINAL para cada produto atualizada*/

      IF @V_DTINICIAL > @P_DTINICIAL+1 BEGIN
         SET @V_DTINICIAL =  @P_DTINICIAL+1;
      END;

      IF @V_DTFINAL < @P_DTFINAL+1 BEGIN
         SET @V_DTFINAL = @P_DTFINAL+1;
      END;


      INSERT INTO LISTA(NRLISTA, CDLISTA)
      (SELECT @V_NRLISTADT, RIGHT('         '+CDLISTA,10)+CONVERT(VARCHAR,@V_DTINICIAL+1, 103)
       FROM LISTA
       WHERE NRLISTA = @V_NRLISTA  AND
       NOT EXISTS
       (SELECT @V_NRLISTADT, CDLISTA
        FROM LISTA
        WHERE NRLISTA = @V_NRLISTADT));

      INSERT INTO LISTA(NRLISTA, CDLISTA)
      (SELECT @V_NRLISTADT, RIGHT('         '+CDLISTA,10)+CONVERT(VARCHAR,@V_DTFINAL, 103)
       FROM LISTA
       WHERE NRLISTA = @V_NRLISTA  AND
       NOT EXISTS
       (SELECT @V_NRLISTADT, CDLISTA
        FROM LISTA
        WHERE NRLISTA = @V_NRLISTADT));


      SET @V_CDPRODUTO = 'X';
      SET @V_DATAPOS   = CONVERT(DATETIME,'01/01/1900');
  /*Atualizao ESTOQUE CONSOLIDADO para os dias em que h registro de nova posio
    entre o perodo informdo */

      DECLARE C_POSESTCONS CURSOR FOR
         SELECT CDPRODUTO, DTPOSIESTQ,
           SUM(QTESTOQDIA)   AS QTESTOQDIA,    SUM(VRESTOQDIA)   AS VRESTOQDIA,
           SUM(VRESTOQDIAM1) AS VRESTOQDIAM1,  SUM(VRESTOQDIAM2) AS VRESTOQDIAM2,
           SUM(QTESTOQANT)   AS QTESTOQANT,    MAX(DTCUSTANT)    AS DTCUSTANT,
           SUM(VRESTOQANT)   AS VRESTOQANT,    SUM(VRESTOQANTM1) AS VRESTOQANTM1,
           SUM(VRESTOQANTM2) AS VRESTOQANTM2,  SUM(VRESTOQBRUT)  AS VRESTOQBRUT,
           SUM(VRESTOQBRUM1) AS VRESTOQBRUM1,  SUM(VRESTOQBRUM2) AS VRESTOQBRUM2,
           SUM(VRBRUTOANT)   AS VRBRUTOANT,    SUM(VRBRUTOANTM1) AS VRBRUTOANTM1,
           SUM(VRBRUTOANTM2) AS VRBRUTOANTM2,  MAX(IDPOSIZERO)   AS IDPOSIZERO,
           SUM(VRCLOGDIA)    AS VRCLOGDIA,     SUM(VRCLOGDIAANT) AS VRCLOGDIAANT,
           SUM(VRCLOGDIAM1)  AS VRCLOGDIAM1,   SUM(VRCLOGDIAAM1) AS VRCLOGDIAAM1,
           SUM(VRCLOGDIAM2)  AS VRCLOGDIAM2,   SUM(VRCLOGDIAAM2) AS VRCLOGDIAAM2,
           SUM(VRSEGUDIA)    AS VRSEGUDIA,     SUM(VRSEGUDIAANT) AS VRSEGUDIAANT,
           SUM(VRSEGUDIAM1)  AS VRSEGUDIAM1,   SUM(VRSEGUDIAAM1) AS VRSEGUDIAAM1,
           SUM(VRSEGUDIAM2)  AS VRSEGUDIAM2,   SUM(VRSEGUDIAAM2) AS VRSEGUDIAAM2
        FROM POSESTDIA , LISTA
        WHERE (CDFILIAL   = @P_FILIMOVI) AND
              (NRLISTA    = @V_NRLISTA)  AND
              (CDPRODUTO  = CDLISTA)     AND
              (DTPOSIESTQ BETWEEN @V_DTINICIAL AND @V_DTFINAL)
        GROUP BY CDFILIAL, CDPRODUTO, DTPOSIESTQ
        ORDER BY DTPOSIESTQ, CDPRODUTO;

      OPEN C_POSESTCONS;
      FETCH NEXT FROM C_POSESTCONS INTO @V_CDPRODPOSEST,  @V_DTPOSICAO,
                                        @V_QTESTOQDIAE,   @V_VRESTOQDIAE,
                                        @V_VRESTOQDIAM1E, @V_VRESTOQDIAM2E,
                                        @V_QTESTOQANTE,   @V_DTCUSTANTE,
                                        @V_VRESTOQANTE,   @V_VRESTOQANTM1E,
                                        @V_VRESTOQANTM2E, @V_VRESTOQBRUTE,
                                        @V_VRESTOQBRUM1E, @V_VRESTOQBRUM2E,
                                        @V_VRBRUTOANTE,   @V_VRBRUTOANTM1E,
                                        @V_VRBRUTOANTM2E, @V_IDPOSIZEROE,
                                        @V_VRCLOGDIAE,    @V_VRCLOGDIAANTE,
                                        @V_VRCLOGDIAM1E,  @V_VRCLOGDIAAM1E,
                                        @V_VRCLOGDIAM2E,  @V_VRCLOGDIAAM2E,
                                        @V_VRSEGUDIAE,    @V_VRSEGUDIAANTE,
                                        @V_VRSEGUDIAM1E,  @V_VRSEGUDIAAM1E,
                                        @V_VRSEGUDIAM2E,  @V_VRSEGUDIAAM2E;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT @V_COUNT = COUNT(*)
         FROM POSESTCONS
         WHERE (CDFILIAL    = @P_FILIMOVI)         AND
               (CDPRODUTO   = @V_CDPRODPOSEST)     AND
               (DTPOSESTCON = @V_DTPOSICAO);

         IF (@V_CDPRODUTO <> @V_CDPRODPOSEST) or (@V_DATAPOS <> @V_DTPOSICAO) BEGIN
            SET @V_CDPRODUTO = @V_CDPRODPOSEST;
            SET @V_DATAPOS   = @V_DTPOSICAO;

            /*Retirada DIA/PRODUTO da lista de dias-produtos a atualizar*/
            DELETE FROM LISTA
            WHERE NRLISTA = @V_NRLISTADT   AND
                  CDLISTA = RIGHT('         '+@V_CDPRODUTO,10)+CONVERT(VARCHAR,@V_DTPOSICAO,103);
         END;

         /*Atualizao POSESTCONS com a soma da POSESTDIA*/
         IF @V_COUNT = 0 BEGIN

            INSERT INTO POSESTCONS
               (CDFILIAL,     CDPRODUTO,    DTPOSESTCON,  QTESTDIACON,  VRESTDIACON,  VRESTDIACOM1,
                VRESTDIACOM2, QTESTANTCON,  DTCUSTANTCON, VRESTANTCON,  VRESTANTCOM1, VRESTANTCOM2, VRESTBRUTCON,
                VRESTBRUTCM1, VRESTBRUTCM2, VRBRUTANTCON, VRBRUTANTCM1, VRBRUTANTCM2, IDPOSZEROCON,
                VRCLOGCON,    VRCLOGCONANT, VRCLOGCONM1,  VRCLOGCONAM1, VRCLOGCONM2,  VRCLOGCONAM2,
                VRSEGUCON,    VRSEGUCONANT, VRSEGUCONM1,  VRSEGUCONAM1, VRSEGUCONM2,  VRSEGUCONAM2)
            VALUES
            (@P_FILIMOVI,      @V_CDPRODPOSEST, @V_DTPOSICAO,
             @V_QTESTOQDIAE,   @V_VRESTOQDIAE,   @V_VRESTOQDIAM1E,
             @V_VRESTOQDIAM2E, @V_QTESTOQANTE,   @V_DTCUSTANTE,
             @V_VRESTOQANTE,   @V_VRESTOQANTM1E, @V_VRESTOQANTM2E,
             @V_VRESTOQBRUTE,  @V_VRESTOQBRUM1E, @V_VRESTOQBRUM2E,
             @V_VRBRUTOANTE,   @V_VRBRUTOANTM1E, @V_VRBRUTOANTM2E,
             @V_IDPOSIZEROE,   @V_VRCLOGDIAE,    @V_VRCLOGDIAANTE,
             @V_VRCLOGDIAM1E,  @V_VRCLOGDIAAM1E, @V_VRCLOGDIAM2E,
             @V_VRCLOGDIAAM2E, @V_VRSEGUDIAE,    @V_VRSEGUDIAANTE,
             @V_VRSEGUDIAM1E,  @V_VRSEGUDIAAM1E, @V_VRSEGUDIAM2E,
             @V_VRSEGUDIAAM2E);
         END
         ELSE BEGIN
            UPDATE POSESTCONS
            SET QTESTDIACON   =  @V_QTESTOQDIAE,
                VRESTDIACON   =  @V_VRESTOQDIAE,
                VRESTDIACOM1  =  @V_VRESTOQDIAM1E,
                VRESTDIACOM2  =  @V_VRESTOQDIAM2E,
                QTESTANTCON   =  @V_QTESTOQANTE,
                DTCUSTANTCON  =  @V_DTCUSTANTE,
                VRESTANTCON   =  @V_VRESTOQANTE,
                VRESTANTCOM1  =  @V_VRESTOQANTM1E,
                VRESTANTCOM2  =  @V_VRESTOQANTM2E,
                VRESTBRUTCON  =  @V_VRESTOQBRUTE,
                VRESTBRUTCM1  =  @V_VRESTOQBRUM1E,
                VRESTBRUTCM2  =  @V_VRESTOQBRUM2E,
                VRBRUTANTCON  =  @V_VRBRUTOANTE,
                VRBRUTANTCM1  =  @V_VRBRUTOANTM1E,
                VRBRUTANTCM2  =  @V_VRBRUTOANTM2E,
                IDPOSZEROCON  =  @V_IDPOSIZEROE,
                VRCLOGCON     =  @V_VRCLOGDIAE,
                VRCLOGCONANT  =  @V_VRCLOGDIAANTE,
                VRCLOGCONM1   =  @V_VRCLOGDIAM1E,
                VRCLOGCONAM1  =  @V_VRCLOGDIAAM1E,
                VRCLOGCONM2   =  @V_VRCLOGDIAM2E,
                VRCLOGCONAM2  =  @V_VRCLOGDIAAM2E,
                VRSEGUCON     =  @V_VRSEGUDIAE,
                VRSEGUCONANT  =  @V_VRSEGUDIAANTE,
                VRSEGUCONM1   =  @V_VRSEGUDIAM1E,
                VRSEGUCONAM1  =  @V_VRSEGUDIAAM1E,
                VRSEGUCONM2   =  @V_VRSEGUDIAM2E,
                VRSEGUCONAM2  =  @V_VRSEGUDIAAM2E
            WHERE (CDFILIAL    = @P_FILIMOVI)         AND
                  (CDPRODUTO   = @V_CDPRODPOSEST)     AND
                  (DTPOSESTCON = @V_DTPOSICAO);
         END;
         FETCH NEXT FROM C_POSESTCONS INTO @V_CDPRODPOSEST,  @V_DTPOSICAO,
                                           @V_QTESTOQDIAE,   @V_VRESTOQDIAE,
                                           @V_VRESTOQDIAM1E, @V_VRESTOQDIAM2E,
                                           @V_QTESTOQANTE,   @V_DTCUSTANTE,
                                           @V_VRESTOQANTE,   @V_VRESTOQANTM1E,
                                           @V_VRESTOQANTM2E, @V_VRESTOQBRUTE,
                                           @V_VRESTOQBRUM1E, @V_VRESTOQBRUM2E,
                                           @V_VRBRUTOANTE,   @V_VRBRUTOANTM1E,
                                           @V_VRBRUTOANTM2E, @V_IDPOSIZEROE,
                                           @V_VRCLOGDIAE,    @V_VRCLOGDIAANTE,
                                           @V_VRCLOGDIAM1E,  @V_VRCLOGDIAAM1E,
                                           @V_VRCLOGDIAM2E,  @V_VRCLOGDIAAM2E,
                                           @V_VRSEGUDIAE,    @V_VRSEGUDIAANTE,
                                           @V_VRSEGUDIAM1E,  @V_VRSEGUDIAAM1E,
                                           @V_VRSEGUDIAM2E,  @V_VRSEGUDIAAM2E;

      END;
      CLOSE C_POSESTCONS;
      DEALLOCATE C_POSESTCONS;
      /*Apaga da tabela POSESTCONS os dias-produto que com a atualizao passaram
       a no possuir registro na POSESTDIA (Ex.: alterao ou excluso de uma lanamento
       de estoque em data que no exista outro lanamento para o produto)*/

      DECLARE C_DELESTLISTA CURSOR FOR
         SELECT distinct LTRIM(SUBSTRING(CDLISTA,0,11))             AS CDPRODLIST,
                CONVERT(DATETIME,SUBSTRING(CDLISTA,11,20)) AS DTPOSESTPROD
         FROM LISTA
         WHERE NRLISTA = @V_NRLISTADT     or NRLISTA = @v_nrlista;
      OPEN C_DELESTLISTA;
      FETCH NEXT FROM C_DELESTLISTA INTO  @V_CDPRODLIST, @V_DTPOSESTPROD;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT @V_DTULTMOVIMEN = MAX(DTULTMOVIMEN)
         FROM POSESTATU
         WHERE (CDFILIAL  = @P_FILIMOVI)              AND
               (CDPRODUTO = @V_CDPRODLIST);

         DELETE POSESTCONS
         WHERE (CDFILIAL    = @P_FILIMOVI)              AND
               (CDPRODUTO   = @V_CDPRODLIST)            AND
               (DTPOSESTCON = @V_DTPOSESTPROD           OR
                DTPOSESTCON  > @V_DTULTMOVIMEN);
        FETCH NEXT FROM C_DELESTLISTA INTO @V_CDPRODLIST, @V_DTPOSESTPROD;
      END;
      CLOSE C_DELESTLISTA;
      DEALLOCATE C_DELESTLISTA;

/*Limpa listas geradas*/
      DELETE LISTA
      WHERE NRLISTA = @V_NRLISTA;

      DELETE LISTA
      WHERE NRLISTA = @V_NRLISTADT;
   END;
END;
GO
-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_ESTOQUE_REC','5.01.010';

